
<!DOCTYPE html>
<?php
    session_start();
    if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './entidades/Arquivo.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];

    $controlador = new ControladorUsuario();
    if (!$controlador->setUser($email)) {
        header("Location: login.php");
    }

    $imageurl = $controlador->getImage();
    $title = $controlador->getTitleName();

    if ($controlador->ehAluno()) {
        include './controladores/Aluno.php';
        include './controladores/Turma.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
    } else {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        $acesso = $controlador->possuiAcesso();
    }

    if ($imageurl != null && $imageurl !== '') {
        $imageurl = $imageurl . '?=' . rand();
    } else {
        $imageurl = 'images/userdefault.png';
    }

    $arquivos = $controlador->listarArquivos();
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Seus Arquivos - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/arquivosstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
            <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Seus Arquivos</p>
                <p>Cadilag</p>
            </div>
            <button id="voltarprincipal" class="pure-button" onclick="window.location='./profile.php'">Voltar para o Principal</button>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl?>'/>
            </div>
        </div>
        <div class="content">
            <div class="arquivosarea">
                <div class="title"><p>Arquivos</p></div>
                <div class="columnnames">
                    <div class="descricao"><p>Descrição</p></div>
                    <div class="data"><p>Data</p></div>
                    <div class="hora"><p>Hora</p></div>
                    <div class="nome"><p>Nome</p></div>
                    <div class="atividade"><p>Atividade</p></div>
                </div>
                <?PHP if(!empty($arquivos)): ?>
                    <div class="arquivos">
                        <?PHP foreach($arquivos as $i=>$arquivo): ?>
                            <div class="arquivo">
                            <div class="descricao"><p><?= $arquivo->getDescricao() ?></p></div>
                            <div class="data"><p><?= $arquivo->getDataFormatada() ?></p></div>
                            <div class="hora"><p><?= $arquivo->getHora() ?></p></div>
                            <div class="nome"><p><?= $arquivo->getNome() ?></p></div>
                            <div class="atividade"><a href="./atividadeview.php?id=<?= $arquivo->getIdatividade() ?>" class="pure-button">Ir</a></div>
                        </div>
                        <?PHP endforeach; ?>
                    </div>
                <?PHP else: ?>
                    <p id="empty">Vazio</p>
                <?PHP endif;?>
            </div>
        </div>
        <?PHP include './includes/navbar.php';?>
    </body>
</html>
