
<!DOCTYPE html>
<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

$firstname = $controlador->getFirstname();
$lastname = $controlador->getLastname();
$nickname = $controlador->getNickname();
$imageurl = $controlador->getImage();

$isAluno = $controlador->ehAluno();
include './controladores/Turma.php';
include './entidades/Arquivo.php';

if (!isset($_GET['id'])) {
    header("Location: class.php");
}
$id = (int) $_GET['id'];

if ($isAluno) {
    include './controladores/Aluno.php';
    $aluno = $controlador->getAluno();
    $turma = $aluno->getTurma();
    if ($turma === null) {
        header("Location: profile.php");
    }
    $selfarquivos = $aluno->listarArquivosDaAtividade($id);
} else {
    include './controladores/Professor.php';
    $professor = $controlador->getProfessor();

    if (isset($_GET['index'])) {
        $index = $_GET['index'];
    } else {
        $index = 0;
    }
    $turma = $professor->getTurmaByIndex($index);
    if ($turma === null) {
        header("Location: class.php");
    }
    $arquivos = $turma->listarArquivosDaAtividade($id);
}

include './entidades/Atividade.php';

$atividade = $turma->getAtividade($id);
if ($atividade === null) {
    header("Location: class.php");
}

$arquivosabertos = $turma->listarArquivosAbertosDaAtividade($id);


if ($imageurl != null && $imageurl !== '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Atividade - <?= $atividade->getTitulo() ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/atividadeviewstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Atividade</p>
                <p>Cadilag</p>
            </div>
            <button class="pure-button" onclick="window.location = '<?= (!$isAluno ? './class.php?index=' . $index : './class.php') ?>';">Ir para a Turma</button>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="content">
            <div class="atividadearea">
                <div class="info">
                    <div class="label"><p><b>Última Revisão: </b></p></div>
                    <div class="text"><p><?= $atividade->getDataRevisaoFormatada() ?><b> ás </b><?= $atividade->getHoraRevisao() ?></p></div>
                    <div class="label"><p><b>Data Limite: </b></p></div>
                    <div class="text"><p><?= $atividade->getDataLimiteFormatada() ?></p></div>
                    <?PHP if (!$isAluno): ?>
                        <button class="editatv" onclick="window.location = './atividadeedit.php?id=<?= $id ?>& index=<?= $index ?>'">Editar</button>
                        <form action="postDeleteAtividade.php" method="POST">
                            <input type="hidden" name="id" value="<?= $id ?>"/>
                            <input type="hidden" name="index" value="<?= $index ?>"/>                                    
                            <button type="button" class="deleteatv">Remover</button>
                        </form>
                    <?php endif; ?>
                </div>
                <div class="description">
                    <div class="label"><p>Titulo</p></div>
                    <div class="text"><p><?= $atividade->getTitulo() ?></p></div>                    
                    <div class="label"><p>Texto</p></div>                    
                    <div class="text"><p><?= nl2br($atividade->getTexto()) ?></p></div>
                </div>
            </div>
            <div class="buttonclosearea" style='display:none'>
                <button class="fechar" onclick="fechararquivo();">Voltar para Atividade</button>
            </div>
            <div class="arquivoarea">
                <div class="title"><p>Arquivos</p></div>
                <div class="subtitle"><p>Arquivos do Professor</p></div>
                <div class="columnnames">
                    <div class="descricao"><p>Descrição</p></div>
                    <div class="data"><p>Data</p></div>
                    <div class="hora"><p>Hora</p></div>                    
                </div>
                <div class="arquivosarea">
                <?PHP if (empty($arquivosabertos)): ?>
                    <p class="vazio">Vazio</p>
                    <?PHP else: foreach ($arquivosabertos as $i => $arquivo): ?>
                        <div class="arquivo <?= ($i % 2 === 0 ? 'odd' : 'even') ?>" id="<?= $arquivo->getId() ?>">
                            <div class="descricao"><p><?= $arquivo->getDescricao() ?></p></div>
                            <div class="data"><p><?= $arquivo->getDataFormatada() ?></p></div>
                            <div class="hora"><p><?= $arquivo->getHora() ?></p></div>                          
                        </div>
                    <?php endforeach; ?> 
                <?PHP endif; ?>
                </div>

                    <?PHP if (!$isAluno): ?>
                        <div class="subtitle"><p>Arquivos dos Alunos</p></div>
                        <div class="columnnames">
                            <div class="descricao"><p>Descrição</p></div>
                            <div class="data"><p>Data</p></div>
                            <div class="hora"><p>Hora</p></div>                    
                        </div>
                        <div class="arquivosarea">
                        <?PHP if (empty($arquivos)): ?>
                                <p class="vazio">Vazio</p>
                            <?PHP else: foreach ($arquivos as $i => $arquivo): ?>
                                    <div class="arquivo <?= ($i % 2 === 0 ? 'odd' : 'even') ?>" id="<?= $arquivo->getId() ?>">
                                        <div class="descricao"><p><?= $arquivo->getDescricao() ?></p></div>
                                        <div class="data"><p><?= $arquivo->getDataFormatada() ?></p></div>
                                        <div class="hora"><p><?= $arquivo->getHora() ?></p></div>                          
                                    </div>
                            <?php endforeach; ?> 
                        <?PHP endif; ?>
                        </div>
                    <?PHP else: ?>
                    <div class="subtitle"><p>Seus Arquivos</p></div>
                    <div class="columnnames">
                        <div class="descricao"><p>Descrição</p></div>
                        <div class="data"><p>Data</p></div>
                        <div class="hora"><p>Hora</p></div>                    
                    </div>
                    <div class="arquivosarea">
    <?PHP if (empty($selfarquivos)): ?>
                            <p class="vazio">Vazio</p>
    <?PHP else: foreach ($selfarquivos as $i => $arquivo): ?>
                                <div class="arquivo <?= ($i % 2 === 0 ? 'odd' : 'even') ?>" id="<?= $arquivo->getId() ?>">
                                    <div class="descricao"><p><?= $arquivo->getDescricao() ?></p></div>
                                    <div class="data"><p><?= $arquivo->getDataFormatada() ?></p></div>
                                    <div class="hora"><p><?= $arquivo->getHora() ?></p></div>                          
                                </div>
        <?php endforeach; ?> 
    <?PHP endif; ?>
                    </div> 
<?PHP endif; ?>
                <div class="subtitle"><p>Adicionar</p></div>
                <form class="pure-form" <?= (!$isAluno ? 'action="./postNovoArquivoProfessor.php"' : 'action="./postNovoArquivoAluno.php"') ?> method="POST" enctype="multipart/form-data">
                    <div class="label"><p>Descrição</p></div>
                    <input required="required" autocomplete="off" style="border-bottom: none;border-bottom-left-radius: 0px;border-bottom-right-radius: 0px;" id="titulo" maxlength="100" name="titulo"/>
                    <div id="counttitulo"><p>0/100</p></div>
                    <input type="hidden" name="id" value="<?= $id ?>"/>
<?PHP if (!$isAluno): ?>
                        <input type="hidden" name="index" value="<?= $index ?>"/>  
<?PHP endif; ?>
                    <input data-max-size="2048" required="required" id="inputfile" type="file" name="url"/>
                    <button id="submitnewfile" class="pure-button pure-button-primary" >Carregar novo Arquivo</button>
                </form>
            </div>
                <?php foreach ($arquivosabertos as $i => $arquivo): ?>
                <div class="arquivodetail" style="display:none" id="<?= $arquivo->getId() ?>">
                    <div class="title"><p>Detahes</p></div>
                    <div class="label"><p>Descrição</p></div>
                    <div class="text"><p><?= $arquivo->getDescricao() ?></p></div>
                    <div class="label"><p>Nome</p></div>
                    <div class="text"><p><?= $arquivo->getPureNome() ?></p></div>
                    <div class="label"><p>Extensão</p></div>
                    <div class="text"><p><?= $arquivo->getExtension() ?></p></div>
                    <div class="label"><p>Tamanho</p></div>
                    <div class="text"><p><?= $arquivo->getSize() ?></p></div>
                    <div class="label"><p>Data de Upload</p></div>
                    <div class="text"><p><?= $arquivo->getDataFormatada() ?></p></div>
                    <div class="label"><p>Hora de Upload</p></div>
                    <div class="text"><p><?= $arquivo->getHora() ?></p></div>   
                    <form action="./download.php" method="POST">
    <?PHP if (!$isAluno): ?>
                            <input type="hidden" name="index" value="<?= $index ?>"/>
    <?PHP endif; ?>
                        <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                        <button class="pure-button pure-button-primary download">Download</button>
                    </form>
    <?PHP if ($arquivo->getIduser() === $controlador->getUserId()): ?>
                        <form action="./postDeleteArquivo.php" method="POST">
                            <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                            <button type="button" class="pure-button delete">Deletar</button>
                        </form>
    <?PHP endif; ?>
                </div>
<?php endforeach; ?>
                    <?PHP if (!$isAluno): ?>
                        <?php foreach ($arquivos as $i => $arquivo): ?>
                    <div class="arquivodetail" style="display:none" id="<?= $arquivo->getId() ?>">
                        <div class="title"><p>Detahes</p></div>
                        <div class="label"><p>Descrição</p></div>
                        <div class="text"><p><?= $arquivo->getDescricao() ?></p></div>
                        <div class="label"><p>Nome</p></div>
                        <div class="text"><p><?= $arquivo->getPureNome() ?></p></div>
                        <div class="label"><p>Extensão</p></div>
                        <div class="text"><p><?= $arquivo->getExtension() ?></p></div>
                        <div class="label"><p>Tamanho</p></div>
                        <div class="text"><p><?= $arquivo->getSize() ?></p></div>
                        <div class="label"><p>Data de Upload</p></div>
                        <div class="text"><p><?= $arquivo->getDataFormatada() ?></p></div>
                        <div class="label"><p>Hora de Upload</p></div>
                        <div class="text"><p><?= $arquivo->getHora() ?></p></div>   
                        <div class="label"><p>Aluno</p></div>
                        <div class="text"><p><?= $arquivo->getTitleAluno() ?></p></div>   
                        <form action="./download.php" method="POST">
        <?PHP if (!$isAluno): ?>
                                <input type="hidden" name="index" value="<?= $index ?>"/>
        <?PHP endif; ?>
                            <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                            <button class="pure-button pure-button-primary download">Download</button>
                        </form>
        <?PHP if ($arquivo->getIduser() === $controlador->getUserId()): ?>
                            <form action="./postDeleteArquivo.php" method="POST">
                                <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                                <button type="button" class="pure-button delete">Deletar</button>
                            </form>
        <?PHP endif; ?>
                    </div>
    <?php endforeach; ?>
                    <?PHP else: ?>
                        <?php foreach ($selfarquivos as $i => $arquivo): ?>
                    <div class="arquivodetail" style="display:none" id="<?= $arquivo->getId() ?>">
                        <div class="title"><p>Detahes</p></div>
                        <div class="label"><p>Descrição</p></div>
                        <div class="text"><p><?= $arquivo->getDescricao() ?></p></div>
                        <div class="label"><p>Nome</p></div>
                        <div class="text"><p><?= $arquivo->getPureNome() ?></p></div>
                        <div class="label"><p>Extensão</p></div>
                        <div class="text"><p><?= $arquivo->getExtension() ?></p></div>
                        <div class="label"><p>Tamanho</p></div>
                        <div class="text"><p><?= $arquivo->getSize() ?></p></div>
                        <div class="label"><p>Data de Upload</p></div>
                        <div class="text"><p><?= $arquivo->getDataFormatada() ?></p></div>
                        <div class="label"><p>Hora de Upload</p></div>
                        <div class="text"><p><?= $arquivo->getHora() ?></p></div>   
                        <form action="./download.php" method="POST">
        <?PHP if (!$isAluno): ?>
                                <input type="hidden" name="index" value="<?= $index ?>"/>
        <?PHP endif; ?>
                            <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                            <button class="pure-button pure-button-primary download">Download</button>
                        </form>
        <?PHP if ($arquivo->getIduser() === $controlador->getUserId()): ?>
                            <form action="./postDeleteArquivo.php" method="POST">
                                <input type="hidden" name="id" value="<?= $arquivo->getId() ?>"/>
                                <button type="button" class="pure-button delete">Deletar</button>
                            </form>
        <?PHP endif; ?>
                    </div>
    <?php endforeach; ?>
                    <?PHP endif; ?>
        </div>
        <?PHP include './includes/navbar.php';?>
        <script>
            
            $("#titulo").keypress(function () {
                $("#counttitulo p").html($(this).val().length + '/100');
            });
            $("#titulo").keyup(function () {
                $("#counttitulo p").html($(this).val().length + '/100');
            });
            
            $(".delete").click(function () {
                var form = $(this).parent();
                swal({
                    title: "Você tem certeza?",
                    text: "Não será possível recuperar o arquivo!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Remover",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: false,
                    closeOnCancel: true},
                        function (isConfirm)
                        {
                            if (isConfirm) {
                                form.submit();
                            }

                        }
                );
            });

            var fechararquivo = function () {

                $(".arquivodetail").fadeOut(500);
                $(".arquivoarea").animate({"margin-left": "0px"}, 500);
                

                setTimeout(function () {
                    $(".buttonclosearea").fadeOut(500);
                    $(".atividadearea").css("display", "block");
                    $(".atividadearea").animate({"width": "620px", 'margin-right': '0px', "margin-bottom": "0px", 'opacity': '1'});
                }, 500);
            };

            $(".arquivo").click(function () {
                var id = $(this).attr('id');

                $(".arquivodetail").fadeOut(500);
                if ($(".atividadearea").css('display') !== 'none')
                {
                    
                    $(".arquivoarea").animate({"margin-left": "-150px"}, 500);

                    $(".arquivodetail[id='" + id + "']").fadeIn(500);

                    setTimeout(function () {
                        $(".buttonclosearea").fadeIn(500);
                        $(".atividadearea").animate({'width': '0px', 'margin-right': '620px', 'opacity': '0', "margin-bottom": "-" + parseInt($(".atividadearea").height() + 180) + "px"}, 500, function () {
                            $(".atividadearea").css("display", "none");
                        });
                    }, 500);
                } else
                {
                    setTimeout(function () {
                        $(".arquivodetail[id='" + id + "']").fadeIn(500);
                    }, 500);
                }
            });

            $(".deleteatv").click(function () {
                var form = $(this).parent();
                swal({
                    title: "Você tem certeza?",
                    text: "Não será possível recuperar as informações da atividade (como arquivos) e pode não haver necessidade de remover uma atividade!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Remover tudo",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: false,
                    closeOnCancel: true},
                        function (isConfirm)
                        {
                            if (isConfirm) {
                                form.submit();
                            }

                        });
            });

        </script>
    </body>
</html>