
<!DOCTYPE html>
<?php
    session_start();
    define( 'CLASSVIEW', true );
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];
    
    $controlador = new ControladorUsuario();
    $controlador->setUser($email);
    $imageurl = $controlador->getImage();
    $isAluno = $controlador->ehAluno();
    
    if(isset($_GET['order'])) {
        $order = $_GET['order'];
    } else {
        $order = 'revisao';
    }
    
    if(isset($_GET['highlight'])) {
        $highlight = $_GET['highlight'];
    } else {
        $highlight = '';
    }
    
    include './entidades/Atividade.php';
    include './entidades/Link.php';
    include './controladores/Turma.php';
    include './entidades/Topico.php';
    include './entidades/MaterialDidatico.php';
     
    $maxpersonal = 3;
    $inipersonal = 0;   
    $index = 0;
    if($isAluno){
        include './controladores/Aluno.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
        $solicitacao = $controlador->getSolicitacao();
        if($turma!==null)
        {
            $topicospersonal = $turma->listarTopicos($inipersonal,$maxpersonal); 
        
            if(!$solicitacao)
            {
                $indexdetail = $turma->getDescricaoTurma();
                $atividadesabertas = $turma->listarAtividadesAbertas($order); 
                $atividades = $turma->listarAtividadesFechadas($order);
                $links = $turma->listarLinks();
                $alunos = $turma->getAlunos();
                $professortitle = $controlador->getTitleNameBy($indexdetail['professor_nome'],$indexdetail['professor_sobrenome'],$indexdetail['professor_apelido'],$indexdetail['professor_email']);
                $materiais = $turma->listarMateriaisDidaticos();
            }
        }
    }
    else{
        $index = 0;
        if(isset($_GET['index']))
        {
            $index = (int)$_GET['index'];
        }
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();    
        $acesso = $controlador->possuiAcesso(); 
        
        if($acesso)
        {
            $turmas = $controlador->getTurmas();
            $turma = $controlador->getTurmaByIndex($index);
            if($turma!=null) {
                $topicospersonal = $turma->listarTopicos($inipersonal,$maxpersonal); 
            } if(!empty($turma)) {
                $links = $turma->listarLinks();
                $alunos = $turma->getAlunos();
                $atividadesabertas = $turma->listarAtividadesAbertas($order); 
                $atividades = $turma->listarAtividadesFechadas($order); 
                $indexdetail = $turma->getDescricaoTurma();
                $professortitle = $controlador->getTitleNameBy($indexdetail['professor_nome'],$indexdetail['professor_sobrenome'],$indexdetail['professor_apelido'],$indexdetail['professor_email']);
                $materiais = $turma->listarMateriaisDidaticos();
            }
            
        }
    }
    if($imageurl!=null && $imageurl!=='')
    {
        $imageurl = $imageurl.'?='.rand();
    }
    else
    {
        $imageurl = 'images/userdefault.png';
    }

?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Turma - Cadilag</title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/classstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    </head>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
            <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Turma</p>
                <p>Cadilag</p>
            </div>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'>
            </div>
            <button class="pure-button" id="voltarprincipal" onclick="window.location='./profile.php';">Voltar para o Principal</button>
            <?php 
                if($isAluno): 
                    include "./includes/includeclasstopbaraluno.php";
                else: 
                    include "./includes/includeclasstopbarprofessor.php";
                endif; 
            ?>
        </div>
        <?php
            if(!$isAluno): 
                include './includes/includeclassprofessor.php';
            else:
                include './includes/includeclassaluno.php';
            endif; 

            include './includes/navbar.php';
        ?>
        
        <script>
           
        <?PHP if(!$isAluno): ?>   

           $(".deleteatv").click(function(){
            var form = $(this).parent();
            swal({   
                title: "Você tem certeza?",   
                text: "Não será possível recuperar os arquivos da atividade!",   
                type: "warning",   
                showCancelButton: true,   
                confirmButtonColor: "#DD6B55",   
                confirmButtonText: "Remover",   
                cancelButtonText: "Cancelar",   
                closeOnConfirm: false,   
                closeOnCancel: true }, 
                    function(isConfirm)
                    {   
                        if (isConfirm) {     
                             form.submit();
                        } 
                        
                    }
                );
           });
        <?PHP else: ?>
                       
           unbindclass = function(){
            swal({   
                title: "Você tem certeza?",
                text: "Você não terá acesso a esta turma e perderá o acesso as estruturas",
                type: "warning",   
                showCancelButton: true,   
                confirmButtonColor: "#DD6B55",   
                confirmButtonText: "Sair",   
                cancelButtonText: "Cancelar",   
                closeOnConfirm: false,   
                closeOnCancel: true }, 
                    function(isConfirm)
                    {   
                        if (isConfirm) {     
                             window.location = './postDesvincular.php';
                        } 
                        
                    }
                );
               
           };
        <?PHP endif; ?>
            
        $("#openatv #order").val("<?= $order ?>");   
        $("#closeatv #order").val("<?= $order ?>");   
           
        $("select").change(function(){
           $(this).parent().submit(); 
        });
           
           
        switch('<?= $highlight ?>')
        {
            case 'openatv':
                $("#openatv").animate({'padding':'30px'},1000,'easeOutQuint',function(){$("#openatv").animate({'padding':'10px'},1000,'easeOutQuint');});
                var obj = $("#openatv");
                $('html, body').animate({scrollTop: obj.offset().top}, 500);
                break;
        }
           
        var objsidebar = document.querySelector('.sidebar');
        if(objsidebar!==undefined && objsidebar!==null)
        {
            objsidebar.style.left='-250px';
            objsidebar.style.left='0px';
        }      
        
        $(".atividade .title").click(function(){
            if($(this).parent().attr('open')==='open')
            {
                $(this).parent().removeAttr('open');
            }
            else
            {
                $(this).parent().attr("open","");
            }
        });
        
        $("select[id='turma']").val('<?= $index; ?>');
        
        $("select[id='turma']").change(function(){
            $("form[id='turma'").submit();
        });
        
        $(".topico").click(function(){
            var id =  $(this).attr("id");
            window.location='./topicoview.php?id='+id;
        });
        </script>
    </body>
</html>
