
<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];
     
    $controlador = new ControladorUsuario();
    if(!$controlador->setUser($email)) {
        header("Location: login.php");
    }
    if($controlador->ehAluno()){
        header("Location: profile.php");
    }
    $imageurl = $controlador->getImage(); 
    $index =0;
    $highlight = '';
    if(isset($_GET['highlight']))
    {
        $highlight = $_GET['highlight'];
    }
    
    
    if(isset($_GET['index']))
    {
        $index = $_GET['index'];
        
    }
    else{
        $_GET['index']=0;
    }

    include './controladores/Professor.php';
    include './controladores/Turma.php';
    include './entidades/Link.php';
    

    $controlador = $controlador->getProfessor();
    $turma = $controlador->getTurmaByIndex($index);
    $details = $turma->getDescricaoTurma();
    $title = $details['disciplina_nome'].' ('.$details['curso_sigla'].') - '.$turma->getAno();   
    $links = $turma->listarLinks();
    
    if($imageurl!=null && $imageurl!=='')
    {
        $imageurl = $imageurl.'?='.rand();
    }
    else
    {
        $imageurl = 'images/userdefault.png';
    }
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Editar Turma - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/classeditstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
            <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Editar Turma</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title; ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        
        <div class="content">
            <p><button class="pure-button" onclick="window.location='./class.php?index=<?= $index ?>';">Voltar</button></p>
            <div class="statusedit">
                    <div class="title"><p>Status</p></div>
                    <div class="subtitle">
                        <p>
                           O status permite informar a situação ou condição atual<br>
                           da disciplina para os membros da turma ou pessoas que<br>
                           desejam entrar nela!
                        </p>
                    </div>
                <form class="pure-form" action="postStatusTurma.php" method="POST">
                    <input name="index" type="hidden" value="<?= $index ?>"/>
                    <p><textarea required="required" name="status" placeholder="Digite aqui!"><?= $turma->getStatus() ?></textarea></p>
                    <p><button class="pure-button pure-button-primary">Salvar</button></p>
                </form>
                
                <details id="infos">
                    <summary><p>DICAS</p></summary>
                    <div class="warning">
                        <p>
                            Você pode utilizar as TAGS: 
                            <br>&ltb&gt para escrever em <b>negrito</b>
                            <br>&lti&gt para escrever em <i>italico</i> 
                            <br>&ltbig&gt para letras maiores
                            <br>&ltsmall&gt para letras menores
                            <br>&ltcenter&gt para alinha uma linha
                            <br>&lth1&gt ... &lth6&gt para Titulos<br>
                            <br>Exemplo: &lti&gt&ltbig&gt texto &lt/big&gt&lt/i&gt -> <i><big>texto</big></i> <br>
                            <br>Não utilizar tags PHP ou atributos em TAG HTML
                            <br>Utilizar Espaço ao lado dos simbolos: '<' (maior) e '>' (menor)
                        </p>
                    </div>
                </details>
            </div>
            <div class="linkedit">
                <div class="title"><p>Links</p></div>
                <div class="subtitle">
                    <p>
                        Links são atalhos para outros materiais fora do Cadilag<br>
                        relacionado á disciplina que serão exibidos somente <br>
                        para os membros da Turma
                    </p>
                </div>
                <form class="pure-form" action="postNovoLink.php" method="POST">
                    <input name="index" type="hidden" value="<?= $index; ?>"/>
                    <div class="label"><p>Titulo (Máximo 45 caracteres)</p></div>
                    <p id="titulo"><input required="required" autocomplete="off" name="titulo"  maxlength="45"/></p>
                    <div id="counttitulo"><p>0/45</p></div>
                    <div class="label"><p>URL</p></div>
                    <p><input required="required" autocomplete="off" name="url"/></p>
                    <p><button class="pure-button pure-button-primary">Adicionar</button></p>
                </form>
                <div class='links'>
                    <div class='title'><p>Links Atuais</p></div>
                    <?php foreach($links as $i=>$link): ?>
                        <a href="<?= $link->getUrl() ?>">
                            <div class="link">
                            <div class="title"><p><?= $link->getTitulo() ?></p></div>
                                <form method="POST" action="./postRemoveLink.php">
                                    <div class="buttonrem" onclick="event.preventDefault();$(this).parent().submit();"></div>
                                    <input name="index" value="<?= $index ?>" type="hidden"/>
                                    <input name="linkid" value="<?= $link->getId() ?>" type="hidden"/>
                                </form>
                            </div>
                        </a>
                    <?PHP endforeach; ?>
                </div>
            </div>

        </div>
        <?PHP include './includes/navbar.php';?>
        <script>
        
        switch('<?= $highlight;?>'){
            case 'status':
                $(".statusedit").animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100); 
                break;
            case 'link':
                $(".linkedit").animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100)
                        .animate({ 'border-color': 'white'},100)
                        .animate({ 'border-color': 'transparent'},100); 
                break;
        }    
        
        $("#titulo input").keypress(function(){
            $("#counttitulo p").html($(this).val().length+'/45');
        });
        $("#titulo input").keyup(function(){
            $("#counttitulo p").html($(this).val().length+'/45');
        });

        </script>
    </body>
</html>
