<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Professor
 *
 * @author joaog
 */
class Professor extends ControladorUsuario{

    public function __construct($id) {
        parent::__construct();
        parent::setUserId($id);
    }
   
    public function possuiAcesso(){
        $iduser = parent::getUserId();
        if($iduser!=-1)
        {
            try {
                $stmt = parent::getConnection()->prepare('SELECT prof_confirmado FROM professor WHERE prof_id=:iduser');
                $stmt->bindParam(':iduser',$iduser, PDO::PARAM_INT);
                $stmt->execute();
                
                $result = $stmt->fetch(PDO::FETCH_ASSOC);
                return $result['prof_confirmado']==='1';
                
            } catch (PDOException $e) {
                echo $e->getMessage();
            }
        }
        return false;
    }
    
    public function getTurmaByIndex($index){

        $iduser = (int)parent::getUserId();
        $turma = false;
        $indexini = (int)$index;
        $indexfim = ($indexini+1);
        if($iduser!=-1) {
            try {
                $stmt = parent::getConnection()->prepare('SELECT * FROM turma WHERE prof_id=:iduser LIMIT :indexini,:indexfim');

                $stmt->bindParam(':iduser',$iduser, PDO::PARAM_INT);
                $stmt->bindParam(':indexini',$indexini, PDO::PARAM_INT);
                $stmt->bindParam(':indexfim',$indexfim, PDO::PARAM_INT);
                $stmt->execute();
                $result = $stmt->fetch(PDO::FETCH_ASSOC);
                
                if($result) {
                    $turma = new Turma($result);
                }
                
            } catch (PDOException $e) {
                echo $e;
            }
        }
        return $turma;
    }
    
    public function getTurmas(){
        
        $lista = null;
        $iduser = parent::getUserId();
        
        if($iduser!=-1)
        {
            try {
                $stmt = parent::getConnection()->prepare('SELECT * FROM turma WHERE prof_id=:iduser');
                $stmt->bindParam(':iduser',$iduser, PDO::PARAM_INT);
                $stmt->execute();

                $lista = array();
                $i=0;
                while ($turma = $stmt->fetch(PDO::FETCH_ASSOC))
                {
                    $lista[$i] = new Turma($turma);
                    $i++;
                }
                
            } catch (PDOException $e) {
                $lista = false;
            }
        }
        return $lista;
    }
    
    public function getTotalSolicitacoes(){
        $result = false;
        $iduser = parent::getUserId();
        try {
            $stmt = parent::getConnection()->prepare('SELECT count(idsolicitacao) as total FROM solicitacao,turma WHERE turma.`idTurma`=solicitacao.`Turma_idTurma` AND turma.prof_id=:iduser');
            $stmt->bindParam(':iduser',$iduser, PDO::PARAM_INT);
            $stmt->execute();
            $fecth = $stmt->fetch(PDO::FETCH_ASSOC);
            $result = (int)$fecth['total'];
            
            
        } catch (PDOException $e) {
            echo ''.$e;
        }
        return $result;
    }
    
    public function novaInstituicao($nome,$uf){
        
       $result = false; 
        try {
            $stmt = parent::getConnection()->prepare('call novaInstituicao(:nome,:uf)');
            $stmt->bindParam(':nome',$nome, PDO::PARAM_STR);
            $stmt->bindParam(':uf',$uf, PDO::PARAM_STR);
            $result = ($stmt->execute() != false);

        } catch (PDOException $e) {
            echo ''.$e;
        }
        return $result;

    }
    public function novoCurso($nome,$sigla,$idinst){
                
       $result = false; 
        try {
            $stmt = parent::getConnection()->prepare('call novoCurso(:nome,:sigla,:id)');
            $stmt->bindParam(':nome',$nome, PDO::PARAM_STR);
            $stmt->bindParam(':sigla',$sigla, PDO::PARAM_STR);
            $stmt->bindParam(':id',$idinst, PDO::PARAM_INT);
            $result = ($stmt->execute() != false);

        } catch (PDOException $e) {
            echo ''.$e;
        }
        return $result;
    } 
    public function novaDisciplina($nome,$idcurso){
        $result = false; 
        try {
            $stmt = parent::getConnection()->prepare('call novaDisciplina(:nome,:id)');
            $stmt->bindParam(':nome',$nome, PDO::PARAM_STR);
            $stmt->bindParam(':id',$idcurso, PDO::PARAM_INT);
            $result = ($stmt->execute() != false);

        } catch (PDOException $e) {
            echo ''.$e;
        }
        return $result;
    }
    public function novaTurma($ano,$semestre,$iddisc){
        $result = false; 
        $iduser = (int)parent::getUserId();
        try {
            $stmt = parent::getConnection()->prepare('call novaTurma(:ano,:semestre,:idprof,:iddisc)');
            $stmt->bindParam(':ano',$ano, PDO::PARAM_INT);
            $stmt->bindParam(':semestre',$semestre, PDO::PARAM_INT);
            $stmt->bindParam(':idprof',$iduser, PDO::PARAM_INT);
            $stmt->bindParam(':iddisc',$iddisc, PDO::PARAM_INT);
            $result = ($stmt->execute() != false);

        } catch (PDOException $e) {
            echo 'error PDO:'.$e;
        }
        return $result;  
    }
    public function responderSolicitacao($id,$resposta){

        $result = false;
        try {
            $stmt = parent::getConnection()->prepare('call responderSolicitacao(:id,:resposta)');
            $stmt->bindParam(':id',$id, PDO::PARAM_INT);
            $stmt->bindParam(':resposta',$resposta, PDO::PARAM_BOOL);
            $stmt->execute();
            $result = true;

        } catch (PDOException $e) {
            echo 'error PDO:'.$e;
        }
        return $result;   
    }
}
?>
