<?php

    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])){
        header("Location: login.php");
    }
    
    if(!isset($_POST['instid'])){
        echo 'instid not found';
        exit();
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    include './entidades/Instituicao.php';
    
    $email = $_SESSION['email'];
    
    $controlador = new ControladorUsuario();
    $controlador->setUser($email);
    
    $isAluno = $controlador->ehAluno();
    $title = $controlador->getTitleName();
    $idinst = $_POST['instid'];
    
    if(!$isAluno)
    {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        if(!$controlador->possuiAcesso())
        {
            header("Location: class.php");
        }
    } else {
        header("Location: class.php");
    }
    $instituicao = $controlador->getInstituicao($idinst); 
    $imageurl = $controlador->getFilteredImage();
    
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Novo Curso - <?= $instituicao->getNome() ?>(<?= $instituicao->getUf() ?>)</title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/classmanagercreatestyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Novo Curso</p>
                <p>Cadilag</p>
            </div>
            <div class='title'><p><?= $instituicao->getNome() ?>(<?= $instituicao->getUf() ?>)</p></div>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="content">
            <div class="subtitle"><p>NOVO CURSO</p></div>
            <div class="title"><p>Insira as informações abaixo</p></div>
            <form class="pure-form" method="POST" action="./postCurso.php">
                <div class="label">Nome</div>
                <input autocomplete="off" maxlength="100" placeholder="Exemplo: Bacharelado de Ciência da Computação" name="nome" type="text"/>
                <div class="label">Sigla</div>
                <input autocomplete="off" maxlength="5" placeholder="Exemplo: BCC" name="sigla" type="text"/>
                <input type="hidden" name="idinstituicao" value='<?= $idinst ?>'/>               
                <button class="pure-button pure-button-primary">Cadastrar</button>
                <button type="button" class="pure-button" onclick="window.location='./classmanager.php';">Voltar</button>
            </form>
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location='./profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location='./editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location='./class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location='./novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            $("#gotohub").click(function(){
                $("#huboptions").fadeToggle(100); 
            });
        </script>
    </body>
</html>