<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];

    $controlador = new ControladorUsuario();
    $controlador->setUser($email);
    $firstname = $controlador->getFirstname();
    $lastname = $controlador->getLastname();
    $nickname = $controlador->getNickname();
    
    if(isset($_POST['typefile'])){
        
        switch($_POST['typefile']) {
            case '0':      
                $imageurl = $_POST['imageurl'];   
                $visibility = '';
                
                break;
            case '1':
                $imageFileType = pathinfo(basename($_FILES['imagefile']["name"]),PATHINFO_EXTENSION);
                $target_dir = 'temp/'.$controlador->getUserId().'.'.$imageFileType;
                $uploadOk = 1;  
                $check = getimagesize($_FILES["imagefile"]["tmp_name"]);
                if($check !== false && ($imageFileType == "jpg" || $imageFileType != "png" || $imageFileType != "jpeg" || $imageFileType != "gif" )) {
                    if (move_uploaded_file($_FILES["imagefile"]["tmp_name"], $target_dir)) {

                    } else {
                        echo "Sorry, there was an error uploading your file.";
                    }
                    $uploadOk = 1;
                } else {
                    echo 'Arquivo não é um tipo de imagem valido:'.$imageFileType;
                    $target_dir = $controlador->getImage();
                    $uploadOk = 0;
                }       
                $visibility = '';
                $imageurl = $target_dir;
                break;
            
        }
        
    } else {
        $imageurl = $controlador->getImage();
        $visibility = 'style="display: none;"';
    }
    
    if(isset($_GET['highlight'])) {
        $highlight = $_GET['highlight'];
    } else {
        $highlight = '';
    }
    
    
    if($imageurl!=null && $imageurl!=='') {
        $pathimage = $imageurl;
    } else {
        $pathimage = 'images/userdefault.png';
    }
     
     $sample_image = $imageurl;

     
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Editar perfil</title>
        <link href='css/jquery.guillotine.css' media='all' rel='stylesheet'>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/editprofilestyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
        <script src="js/jquery.ui.touch-punch.min.js"></script>
        <script src='js/jquery.guillotine.js'></script>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery.complexify.js"></script>
        <script src="js/jquery.complexify.min.js"></script>
        <script src="js/jquery.complexify.banlist.js"></script>
        
    <body>
        <div class='topbar'>
            <a href="./profile.php">
            <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Editar perfil</p>
                <p>Cadilag</p>
            </div>
        </div>
        <div class='area'>
            <div class='title'>
                <p>Principal</p>
            </div>
            <div id='inputs'>
                <form class="pure-form">
                    <div class="label"><p>Apelido</p></div>
                    <input id='nickname' value="<?= $nickname; ?>" maxlength="40"/>
                    <div class="label"><p>Primeiro Nome</p></div>
                    <input id='firstname' value="<?= $firstname; ?>" maxlength="40"/>
                    <div class="label"><p>Último Nome</p></div>
                    <input id='lastname' value="<?= $lastname; ?>" maxlength="40"/>
                    <button type='button' id='editimage'>Alterar imagem</button>
                    <button type='button' id='editpassword'>Alterar senha</button>
                </form>
            </div>
            <div id='imageuser'>
                <div class="label"><p>Imagem do Perfil</p></div>
                <img id='imguser' onload="oncomplete();" alt='Imagem do Perfil' src='<?= $pathimage ?>?=<?= rand() ?>'/>
            </div>
        </div>
        <div class='editpassword' style="display: none">
            <div class='title'>
                <p>Alterar Senha</p>
            </div>
            <form class="pure-form">
                <input required="required" placeholder="Senha Atual" id="oldpassword" type="password"/>
                <input required="required" placeholder="Nova Senha" onkeypress="capsLockDetector(event)" status="scan" id="password" type="password"/>
                <div id="alertCaps" style="display:none;clear: both;top:5px;">Caps Lock está ativo</div>
                <div style="margin-top:10px;" class="progress"><div id="float"></div></div>
                <div class='alert' style="text-align: center">
                    A barra acima mostrar a força da senha. Tente uma senha <b style="color:#88F">AZUL</b> ou <b style="color:#8F8">VERDE</b>
                    <details style="cursor: default">
                        <summary>Ajuda</summary>
                        <p>Use letras e numeros, e não utilize palavras conhecidas!</p>
                    </details>
                </div>
                <input style="margin-top:10px" class='pure-input-1' onkeypress="capsLockDetector(event)" placeholder="Redigite a nova senha" id="passwordC" type="password" name="passwordC"  />
                <button type="button" class="pure-button pure-button-primary" id="action">Alterar</button>
                <button type="button" id='closeEditPass' class='pure-button'>Cancelar</button>
            </form>
        </div>
        <div class='editimage' <?= $visibility; ?>>
            <div class='frame'>
               <img id='sample_picture' alt='pre-visualização' src='<?= $sample_image; ?>'>
               <form class="pure-form" id='imageupdate' method='POST' action="editprofile.php" enctype="multipart/form-data">
                    <input placeholder="Ou utilize uma URL da imagem e aperte Enter" name='imageurl' id='imageurl' value="<?= (isset($_POST['imageurl'])?$_POST['imageurl']:'') ?>"/>
                    <input accept="image/*" id='imagefile' type='file' name='imagefile'/>
                    <input id="typefile" name='typefile' value='0' type="hidden"/>
               </form>
               <form class="pure-form" id="usechar">
                   <button type="button" class="pure-button">Utilizar caractere</button>
               </form>
               <form class="pure-form" id="usedefault">
                   <button type="button" class="pure-button">Utilizar padr&atilde;o</button>
               </form>
            </div>
            <form class="pure-form">
                <table id='controls'>
                    <tr>
                        <td><button id='saveimage' class="pure-button"  type='button' title='Save'> Salvar Imagem </button></td>
                        <td><button id='zoom_out'  class="pure-button"  type='button' title='Zoom out'> ➖ </button></td>
                        <td><button id='fit' class="pure-button"   type='button' title='Fit image'> ▭  </button></td>
                        <td><button id='zoom_in' class="pure-button"   type='button' title='Zoom in'> ➕ </button></td>
                        <td><button id='closeimage' class="pure-button"  type='button' title='Fechar'> Fechar </button></td>
                    </tr>
                </table>
            </form>
        </div>
        <div id="imageoptions" style="display: none">
            <button id="reload" onclick="window.location ='editprofile.php?highlight=image'"></button>
        </div>
        
        <div class='buttons'>
            <button id='save'>Salvar</button>
            <button id='cancel'>Voltar</button>
        </div>
        <div id='imageinfo' style="visibility: hidden;"></div>
        <div class='loadingscreen' style="display:none;"></div>
        <script>
            
            function capsLockDetector(e) {
                kc = e.keyCode ? e.keyCode : e.which;
                sk = e.shiftKey ? e.shiftKey : ((kc === 16) ? true : false);
                if (((kc >= 65 && kc <= 90) && !sk) || ((kc >= 97 && kc <= 122) && sk))
                    document.getElementById('alertCaps').style.display = 'block';
                else
                    document.getElementById('alertCaps').style.display = 'none';
            }
            $(".editpassword #action").click(function(){
                
                var senha = $('.editpassword #password').val();
                var senhaC = $('.editpassword #passwordC').val();

                if (senha === '') {
                    swal("Senha nova", 'está faltando', 'error');
                    return;
                }
                if (senha!==senhaC) {
                    swal("As senhas são diferentes", 'Isso evita que você insira uma senha incorreta ou aleatória!', 'error');
                    return;
                }

                
                $(".loadingscreen").fadeIn(400);
                var form = $(".editpassword form");
                var postData = {oldpassword:form.find("#oldpassword").val(),newpassword:form.find("#password").val()};
                $.post("./ajax/changePassword.php",postData,function(dataencoded){
                    try{
                        var retorno = JSON.parse(dataencoded);
                        if(retorno.resultado){
                            swal({title:'Senha alterada',text:'Ao iniciar a sessão novamente, utilize a nova senha!'});
                            $(".editpassword").fadeOut(400);
                            $(".loadingscreen").fadeOut(400);
                        } else {
                            $(".loadingscreen").fadeOut(400);
                            swal({title:'Error',text:retorno.resposta,type:'error'});
                            window.console.log(retorno);
                        }
                    } catch(e) {
                        $(".loadingscreen").fadeOut(400);
                        swal({title:'Error',text:"Erro interno",type:'error'});
                        console.log(e);
                        console.log(dataencoded);
                    }
                });
            });
            $("#usechar button").click(function(){
                
                var char = '<?= substr($controlador->getTitleName(),0,1) ?>';
                char = char.toLowerCase();
                var postData = { "url" : "users/image/"+char+".png" } ;
                
                $.post("./ajax/setImage.php",postData,function(data1,status){
                    $(".loadingscreen").fadeOut(400);
                    $(".editimage").fadeOut(400);
                    location.reload();
                }); 
                
            });
            
            $("#usedefault button").click(function(){
                
                var postData = { "url" : "images/userdefault.png" } ;
                
                $.post("./ajax/setImage.php",postData,function(data1,status){
                    $(".loadingscreen").fadeOut(400);
                    $(".editimage").fadeOut(400);
                    location.reload();
                }); 
                
            });
            
            $("#sample_picture").on('DOMMouseScroll mousewheel', function ( event ) {
                if( event.originalEvent.detail > 0 || event.originalEvent.wheelDelta < 0 ) {
                  $(this).guillotine('zoomOut');
                } else {
                  $(this).guillotine('zoomIn');
                }
                return false;
            });
            
            $("#cancel").click(function(){
                window.location.replace("./profile.php");
            });
            
            $("#save").click(function(){
                var nickname = $("#nickname").val();
                var firstname = $("#firstname").val();
                var lastname = $("#lastname").val();
                   
                nickname = nickname.replace(/[0-9]*/g,"");
                
                firstname = firstname.replace(/[0-9]*/g,"");
                
                lastname = lastname.replace(/[0-9]*/g,"");
                     
                var postData = {
                    "nickname":nickname,"firstname":firstname,"lastname":lastname
                };
                
                $.post("./ajax/saveeditprofile.php",postData,function(data,status){
                   window.location.replace("./profile.php");
                });
                
                
            });
            $("#closeimage").click(function(){
                $(".editimage").fadeOut(400);
                $("#imageoptions").fadeOut(400);
            });
            
            document.getElementById("imagefile").onchange = function() {
                $("#typefile").val('1');
                $("#imageurl").val('');
                document.getElementById("imageupdate").submit();
            };
            
            $('#imageurl').keyup(function(e){
                if(e.keyCode === 13) {
                    document.getElementById("imageupdate").submit();
                }
            });
            
            $("#saveimage").click(function(){
                
                $(".loadingscreen").fadeIn(400);
               
                var url = $("#imageurl").val();
                var x = $("#imageinfo").attr('x');
                var y = $("#imageinfo").attr('y');
                var w = $("#imageinfo").attr('w');
                var h = $("#imageinfo").attr('h');                
                var s = $("#imageinfo").attr('s');
                var si = $("#imageinfo").attr('si');
                
                if(url==='') {
                    url = $("#sample_picture").attr('src');
                }
                
                var postData = {
                    "url":url,"x":x,"y":y,"w":w,"h":h,"s":s,'is':si
                };
                
                $.post("./ajax/uploadImage.php",postData,function(dataencoded,status){
                    try {
                        var retorno = JSON.parse(dataencoded);
                        if(retorno.resultado){
                            swal({title:'Sucesso'});

                            postData = {
                                "url":retorno.url
                            };
                            $.post("./ajax/setImage.php",postData,function(data1,status){
                                $(".loadingscreen").fadeOut(400);
                                $(".editimage").fadeOut(400);
                                $("#imguser").attr('src',retorno.url+'?='+Math.random());
                            });
                        } else {
                            $(".loadingscreen").fadeOut(400);
                            swal({title:'Error',text:retorno.respota,type:'error'});
                            window.console.log(retorno);
                        }
                    } catch(e) {
                        alert("falha interna no servidor");
                        console.log(dataencoded);
                    }
                });
                
                
            });

            $("#closeEditPass").click(function(){
                $(".editpassword").fadeOut(400);
            });

            $("#editimage").click(function(){
                $(".editimage").fadeIn(400);
                $("#imageoptions").fadeIn(400);
                $(".editpassword").fadeOut(400);
            });
            
            $("#editpassword").click(function(){
                $(".editimage").fadeOut(400);
                $("#imageoptions").fadeOut(400);
                $(".editpassword").fadeIn(400);
            });
            
            function oncomplete(){

                jQuery(function() {
                    var picture = $('#sample_picture');

                    // Make sure the image is completely loaded before calling the plugin
                    picture.on('load', function(){
                      // Initialize plugin (with custom event)
                      picture.guillotine({eventOnChange: 'guillotinechange'});

                      // Bind button actions
                      $('#fit').click(function(){ picture.guillotine('fit'); });
                      $('#zoom_in').click(function(){ picture.guillotine('zoomIn'); });
                      $('#zoom_out').click(function(){ picture.guillotine('zoomOut'); });


                    });

                    picture.guillotine({
                     width: 500,
                     height: 500,
                     init: {width:500,height:500},
                     onChange: function(data, action){
                          data = picture.guillotine('getData');
                          $("#imageinfo").attr('x',data.x);
                          $("#imageinfo").attr('y',data.y);
                          $("#imageinfo").attr('w',data.w);
                          $("#imageinfo").attr('h',data.h);
                          $("#imageinfo").attr('s',data.scale);
                        }
                   });
                   picture.guillotine('fit');
                   var data = picture.guillotine('getData');
                    $("#imageinfo").attr('x',data.x);
                    $("#imageinfo").attr('y',data.y);
                    $("#imageinfo").attr('w',data.w);
                    $("#imageinfo").attr('h',data.h);
                    $("#imageinfo").attr('s',data.scale);
                    $("#imageinfo").attr('si',data.scale);        
                    picture.on('guillotinechange', function(ev, data, action) {
                        data.scale = parseFloat(data.scale.toFixed(4));
                        for(var k in data) { $('#'+k).html(data[k]); }
                      });

                    switch('<?= $highlight ?>')
                    {
                        case 'image':
                            $("#imageoptions").fadeIn(100);
                            $(".editimage").fadeIn(100,
                                function(){
                                    $(".editimage").animate({'box-shadow':'0px 0px 10px rgba(255,255,255,1)'},400,function(){
                                        $(".editimage").animate({'box-shadow':'0px 0px 10px rgba(255,255,255,0)'},400); 
                                    });
                                });break;
                    }

    //                // Make sure the 'load' event is triggered at least once (for cached images)
    //                if (picture.prop('complete')) picture.trigger('load');
                });
            }
        </script>
        <script src="js/ScriptComplexify.js"></script>
    </body>
</html>
