<?php

/**
 * Description of MateriaisDidaticos
 *
 * @author joaog
 */
class MaterialDidatico {
 
    private $id;
    private $titulo;
    private $detalhes;
    private $caminho;
    private $data;
    private $hora;
    private $idturma;
    
    public function __construct($row) {
        $this->id = $row['idMaterialDidatico'];
        $this->titulo = $row['rotulo'];
        $this->detalhes = $row['detalhes'];
        $this->caminho = $row['pathArquivo'];
        $this->idturma = $row['Turma_idTurma'];
        $this->data = $row['data'];
        $this->hora = $row['hora'];
    }
    
    public function getId() {
        return $this->id;
    }

    public function getTitulo() {
        return $this->titulo;
    }

    public function getDetalhes() {
        return $this->detalhes;
    }

    public function getCaminho() {
        return $this->caminho;
    }

    public function getData() {
        return $this->data;
    }

    public function getHora() {
        return $this->hora;
    }
    
    public function getDataFormatada() {
        return date("d/m/Y", strtotime($this->data));
    }

    public function getHoraMinimizada() {
        return substr($this->hora,0,5);
    }
    
    public function getIdturma() {
        return $this->idturma;
    }
    
    public function getExtension(){
        $result = pathinfo(basename($this->getCaminho()),PATHINFO_EXTENSION);
        if(empty($result))
        {
            $result = "Desconhecido\Não Definido";
        }
        return $result;
    }

    public function getSize(){
        $bytes = filesize($this->caminho);
        if ($bytes >= 1073741824)
        {
            $bytes = number_format($bytes / 1073741824, 2) . ' GB';
        }
        elseif ($bytes >= 1048576)
        {
            $bytes = number_format($bytes / 1048576, 2) . ' MB';
        }
        elseif ($bytes >= 1024)
        {
            $bytes = number_format($bytes / 1024, 2) . ' KB';
        }
        elseif ($bytes > 1)
        {
            $bytes = $bytes . ' bytes';
        }
        elseif ($bytes == 1)
        {
            $bytes = $bytes . ' byte';
        }
        else
        {
            $bytes = '0 bytes';
        }

        return $bytes;

    }
   
    public function getNome() {
        return substr(basename($this->getCaminho()),strlen($this->id)+1);
    }
    
    public function getPureNome() {
        $orginal = basename($this->getCaminho());
        $idsize = strlen($this->id)+1;
        return substr($orginal,$idsize,strlen($orginal)-strlen(pathinfo(basename($this->getCaminho()),PATHINFO_EXTENSION))-1-$idsize);
    }
    
}
