<?php

session_start();

if (!isset($_SESSION['email']) ||
        !isset($_SESSION['senha']) ||
        !isset($_POST['dataAdd']) ||
        !isset($_POST['dataRem']) ||
        !isset($_POST['dataSearch'])) {
    echo json_encode(array("success" => false, "reply" => "Erro de Parametrização"));
}

include '../../../config/Database.php';
include '../controladores/PDOCadilag.php';
include '../controladores/CodePDO.php';
include '../controladores/ControladorCodigos.php';

$rotulo = filter_input(INPUT_POST, 'title', FILTER_SANITIZE_STRING);
$language = filter_input(INPUT_POST, 'language', FILTER_SANITIZE_STRING);
$codeAdd = $_POST['dataAdd'];
$codeRem = $_POST['dataRem'];
$codeSearch = $_POST['dataSearch'];
$id = (int) (filter_input(INPUT_POST, 'idEstrutura', FILTER_VALIDATE_INT));

if($rotulo && $language && $id){
    $email = $_SESSION['email'];
    $password = $_SESSION['senha'];

    $controladorCode = new controladores\ControladorCodigos();

    if (!$controladorCode->checkAcess($email, $password)) {
        echo json_encode(array("success" => false, "reply" => "Erro de Sessão"));
        exit();
    }
    
    $resultSQL = $controladorCode->registerNewCode(
            $id,$rotulo,$language,
            json_encode($codeAdd, JSON_UNESCAPED_UNICODE),
            json_encode($codeRem, JSON_UNESCAPED_UNICODE),
            json_encode($codeSearch, JSON_UNESCAPED_UNICODE));
    echo json_encode($resultSQL);
} else {
    echo json_encode(array("success" => false, "reply" => "Falha de Filtro"));
}
    
