<?php

namespace controladores;

use PDO;
use config\Database;
use entidades\EntradaProgramada;

class ControladorEp {

    private $connection;

    public function __construct() {
        try {
            $this->connection = new EpPDO(
                    'mysql:host=localhost;dbname=' . Database::$mysql_dbname, Database::$mysql_user, Database::$mysql_password
            );
        } catch (PDOException $e) {
            echo '<code>' . $e->getMessage() . '</code>';
            die();
        }
    }

    public function checkAcess($email, $password) {
        return $this->connection->checkAcess($email, $password);
    }

    public function getJSON($idEp) {
        try {
            $stmt = $this->connection->getJsonStmt($idEp);
            $resultPDO = $stmt->execute();
            if ($resultPDO && $stmt->rowCount() == 1) {
                $result = $stmt->fetch(PDO::FETCH_ASSOC);
                return array("success" => true, "rotulo" => $result['descricao'], "json" => $result['json'], "idEstrutura" => $result['Estrutura_De_Dado_ed_id']);
            } else {
                return array("success" => false, "reply" => "Falha ao executar o Script");
            }
        } catch (Exception $ex) {
            return array("success" => false, "reply" => $ex->getMessage());
        }
    }

    public function updateEP($rotulo, $id, $total, $json) {
        try {
            $stmt = $this->connection->updateStmt($rotulo, $id, $total, $json);
            $resultPDO = $stmt->execute();
            if ($resultPDO) {
                $stmt = $this->connection->descriptionStmt($id);
                $resultPDO = $stmt->execute();
                $result = $stmt->fetch(PDO::FETCH_ASSOC);
                return array("success" => true, "rotulo" => $result['rotulo'], "data" => $result['data'], "hora" => $result['hora'], "Sucesso ao alterar", "resultPDO" => $resultPDO);
            } else {
                return array("success" => false, "reply" => "Falha ao executar o script", "resultPDO" => $resultPDO);
            }
        } catch (PDOException $e) {
            return array("success" => false, "reply" => $e->getMessage());
        }
    }

    public function registerNewEP($rotulo, $idEstrutura, $totalEp, $json) {
        try {
            $stmt = $this->connection->insertStmt($idEstrutura, $rotulo, $totalEp, $json);
            $resultPDO = $stmt->execute();
            $id = $this->connection->lastInsertId('idEntradaProgramada');
            return array("success" => $resultPDO, "resultSQL" => $resultPDO, "lastInsertId" => $id);
        } catch (PDOException $e) {
            echo $e->getMessage();
        }
        return array("success" => false, "reply" => $e->getMessage());
    }

    public function deleteEp($idEp) {
        try {
            $stmt = $this->connection->deleteStmt($idEp);
            $resultPDO = $stmt->execute();
            if ($resultPDO) {
                return array("success" => true, "reply" => "Sucesso na execução do SQL");
            } else {
                return array("success" => false, "reply" => "Falha ao Executar o Script");
            }
        } catch (PDOException $e) {
            return array("success" => false, "reply" => $e->getMessage());
        }
    }

    public function listEp($idEstrutura) {
        try {
            $stmt = $this->connection->listaStmt($idEstrutura);
            $resultPDO = $stmt->execute();
            if ($resultPDO) {
                $lista = array();
                while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                    $lista[] = new EntradaProgramada($row);
                }
                return array("success" => true, "reply" => "Sucesso na execução do SQL", "lista" => $lista);
            } else {
                return array("success" => false, "reply" => "Erro na execução do SQL");
            }
        } catch (PDOException $e) {
            return array("success" => false, "reply" => $e->getMessage());
        }
    }

}
