<?PHP
session_start();

if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: ../../login.php");
}

include '../../config/Database.php';
include '../../controladores/ControladorUsuario.php';

$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
$controlador->setUser($email);
$imageurl = $controlador->getImage();
$isAluno = $controlador->ehAluno();
$isProfessor = !$isAluno;

define('STRUCTVIEW', true);
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <link href="../../images/cadilag.svg" rel="shortcut icon"/>
        <title>Cadilag Estruturas</title>
        <link href="../../css/CadilagStructs/index.css" rel="stylesheet"/>
        <link href="../../css/CadilagStructs/estruturas.css" rel="stylesheet"/>
        <script src="../../js/CadilagStructs/jquery-3.1.1.min.js" type='text/javascript'></script>
        <script src="../../js/CadilagStructs/jquery-ui.min_1.js" type='text/javascript'></script>
        <script src='../../js/CadilagStructs/jquery.ui.touch-punch.min.js' type='text/javascript'></script>
    </head>
    <body>
        <div id="sidebar">
            <a href="../../profile.php"><div class="title">Cadilag</div></a>
            <div class="subtitle">Estruturas</div>
            <?PHP
            if ($isAluno) {
                include '../../controladores/Aluno.php';
                include '../../controladores/Turma.php';
                $controlador = $controlador->getAluno();
                $turma = $controlador->getTurma();
                if ($turma !== null) {
                    include './includes/index/sidebaraluno.php';
                } else {
                    include './includes/index/sidebaralunobloqueado.php';
                }
            } elseif ($isProfessor) {
                include '../../controladores/Professor.php';

                $controlador = $controlador->getProfessor();
                $acesso = $controlador->possuiAcesso();
                if ($acesso) {
                    include './includes/index/sidebarprofessor.php';
                } else {
                    include './includes/index/sidebarprofessorbloqueado.php';
                }
            }
            ?>
            <a href="../../profile.php"><button id="back">Voltar para o Inicio</button></a>
            <!--<div class="bookmark"></div>-->
        </div>
        <?PHP
        if (($isAluno && $turma != null) || ($isProfessor && $acesso)) {
            include './includes/index/estruturas.php';
        }
        include './includes/index/navbar.php';
        ?>
    </body>
</html>
