$( document ).ready(function() {
    Plumb.setPrimaryColor("#0000ff");
    Plumb.setSecondaryColor("#ff0000");
});
//Midleware JsPlumb
//v 2.1.7

(function () {

    window.Plumb = {
        color1:"#0000ff",color1light:"#5555ff",color2:"#ff0000",color2light:"#ff5555",
        config:{
            deleteEndpointsOnDetach:false
        },
        setPrimaryColor:function(rgb){
            this.color1 = rgb;
            this.color1light = this.lightColor(rgb.substring(1));
        },
        setSecondaryColor:function(rgb){
            this.color2 = rgb;
            this.color2light = this.lightColor(rgb.substring(1));            
        },
        componentToHex:function(c) {
            var hex = c.toString(16);
            return hex.length === 1 ? "0" + hex : hex;
        },
        rgbToHex:function(r, g, b) {
            return "#" + this.componentToHex(r) + this.componentToHex(g) + this.componentToHex(b);
        },
        lightColor:function(hex){
            var bigint = parseInt(hex, 16);
            var r = (bigint >> 16) & 255;
            var g = (bigint >> 8) & 255;
            var b = bigint & 255;
            return this.rgbToHex(parseInt((r*2+255)/3),parseInt((g*2+255)/3),parseInt((b*2+255)/3));
        },
        moveTo:function(idDoElemento,left,top,time){ //Não gera fila de animação
            $("#"+idDoElemento).animate({left:left,top:top},{duration:time,easing:"easeOutCubic",complete:function(){
                Plumb.repintarElemento(idDoElemento);
            },step:function(){
                Plumb.repintarElemento(idDoElemento);
            }});

        },
        init:function(deleteEndpointsOnDetach){
            
            jsPlumb.importDefaults({
                DragOptions: {cursor: "grab", zIndex: 20},
                Connector: ["Straight"],
                ConnectionsDetachable: false
            });
            
            if(deleteEndpointsOnDetach!==undefined)
                this.config.deleteEndpointsOnDetach = deleteEndpointsOnDetach;
        },
        tornarArrastavel:function(idDoElemento){
            jsPlumb.draggable(idDoElemento);
        },
        repintarTudo:function(){
            jsPlumb.repaintEverything();
        },
        repintarElemento:function(idDoElemento){
            jsPlumb.revalidate(idDoElemento);
        },
        adicionarPontoDeConexao:function(idDoElemento,parametros){
            
            var format,colorC;
            
            if(parametros.isPrimary) {
                format = {fillStyle: this.color1light,radius: 5};
                colorC = this.color1;
            } else {
                format = {fillStyle: this.color2light,radius: 5};
                colorC = this.color2;
            }
            
            var endpoint = jsPlumb.addEndpoint(idDoElemento, {
                anchor: parametros.anchor,
                paintStyle: format,
                connectorStyle: {lineWidth: 3, strokeStyle: colorC},
                connectorHoverStyle: {lineWidth: 4},
                endpointsOnTop: true,
                isSource: parametros.isSource,
                isTarget: parametros.isTarget,
                enabled: false
            });

            if(parametros.type!==undefined){
                switch (parametros.type){
                    case "Flowchart":endpoint.connector = ["Flowchart", {stub: [30, 30], alwaysRespectStubs: true}];
                }
            }
            
            endpoint.isPrimary = parametros.isPrimary;
            return endpoint;
        },
        desconectarCompletamente:function(elId){
            jsPlumb.remove(elId);
        },
        desconectar:function(parametros){
            var cnc = jsPlumb.getConnections(parametros);
            if (cnc[0] !== null && cnc[0] !== "undefined" && cnc[0]!==undefined)
                jsPlumb.detach(cnc[0]);
        },
        desconectarTodosCom:function(parametros){
            var cnc = jsPlumb.getConnections(parametros);
            for(var i=0;i<cnc.length;i++)
                if (cnc[i] !== null && cnc[i] !== "undefined" && cnc[i]!==undefined)
                    jsPlumb.detach(cnc[i]);
        },
        conectar:function(origem,destino){
            var overlays;
            var color;
            
            if(origem.isPrimary) {
                color = this.color1;
            } else {
                color = this.color2;
            }
            if(origem.isTarget && destino.isTarget) {
                overlays = 
                    [[
                        "PlainArrow", {
                            location: 1,
                            direction: 1,
                            width: 13,
                            length: 15,
                            paintStyle: {
                                fillStyle: color
                            }
                        }
                    ],[
                        "PlainArrow", {
                        location: 0,
                        width: 13,
                        direction: -1,
                        length: 15,
                        paintStyle: {
                            fillStyle: color
                        }
                    }]];
            } else if(origem.isTarget && !destino.isTarget) {
                overlays = 
                    [[
                        "PlainArrow", {
                            location: 0.5,
                            direction: 1,
                            width: 13,
                            length: 15,
                            paintStyle: {
                                fillStyle: color
                            }
                        }
                    ]];
            } else if(!origem.isTarget && destino.isTarget) {
                overlays = 
                    [[
                        "PlainArrow", {
                            location: 0.5,
                            direction: -1,
                            width: 13,
                            length: 15,
                            paintStyle: {
                                fillStyle: color
                            }
                        }
                    ]];
            }
            var connection = jsPlumb.connect({source: origem, target: destino, deleteEndpointsOnDetach: this.config.deleteEndpointsOnDetach},{overlays:overlays});
            return connection;
        }
    };
    
})();