jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function Trie() {
    this.raiz = null;
    this.size = null;

    Trie.criaNo = function () {
        return{
            ref: null,
            id: null,
            d: null,
            fimChave: null,
            chave: null,
            prox: null,
            baixo: null,
            ant: null
        };
    };

    Trie.criaRef = function () {
        return {ref: null};
    };

    this.inicia = function () {
        this.raiz = Trie.criaRef();
    },
    this.insere = function (elem) {
        if (this.raiz == null)
            this.inicia();

        this.insere2(this.raiz, elem, 0);
    },
    this.insere2 = function (t, elem, ind) {

        if (elem.length != ind) {
            if (t.ref == null) {

                t.ref = Trie.criaNo();

                if (t.ref) {
                    t.ref.fimChave = ind + 1 == elem.length;
                    t.ref.prox = Trie.criaRef();
                    t.ref.ant = Trie.criaRef();
                    t.ref.baixo = Trie.criaRef();
                    t.ref.ref = elem[ind].ref;
                    t.ref.id = elem[ind].id;
                    t.ref.d = elem[ind].d;
                    t.ref.chave = elem[ind].valor;
                }

                this.insere2(t.ref.baixo, elem, ind + 1);
            } else {
                var ant = null;
                var aux = t;

                while (aux.ref && aux.ref.chave < elem[ind].valor) {
                    ant = aux;
                    aux = aux.ref.prox;
                }

                if (aux.ref == null) {
                    this.insere2(aux, elem, ind);
                    ant.ref.prox = aux;
                    aux.ref.ant = ant;
                } else if (aux.ref.chave > elem[ind].valor) {
                    if (ant == null) {
                        var novo = Trie.criaRef();
                        this.insere2(novo, elem, ind);

                        novo.ref.prox.ref = t.ref;
                        t.ref.ant.ref = novo.ref;
                        t.ref = novo.ref;

                    } else {
                        var aux2 = Trie.criaRef();
                        this.insere2(aux2, elem, ind);
                        aux2.ref.prox = aux;
                        aux.ref.ant = aux2;
                        aux2.ref.ant = ant;
                        ant.ref.prox = aux2;
                    }

                } else {
                    if (ind + 1 >= elem.length)
                        aux.ref.fimChave = true;
                    else
                        this.insere2(aux.ref.baixo, elem, ind + 1);
                }
            }
        }
    },
    this.remove = function (raiz, ultimo, ultimopai) {
        if (raiz.ref.baixo.ref != null)
            raiz.ref.fimChave = false;

        else {
            if (raiz.ref.prox.ref == null && raiz.ref.ant.ref == null) {
                if (ultimo.ref.fimChave == true)
                    ultimo.ref.baixo.ref = null;

                else {
                    if (ultimo.ref.prox.ref != null)
                        ultimo.ref.prox.ref.ant = ultimo.ref.ant;

                    if (ultimo.ref.ant.ref != null)
                        ultimo.ref.ant.ref.prox = ultimo.ref.prox;

                    if (ultimopai == null) {
                        if (ultimo.ref.ant.ref == null) {
                            if (ultimo.ref.prox.ref != null) {
                                this.raiz = ultimo.ref.prox;
                                deslocarRamificacao(this.raiz, -80, 0, 0);
                            } else
                                this.raiz = Trie.criaRef();
                        }
                    } else if (ultimopai.ref.baixo == ultimo)
                        ultimopai.ref.baixo = ultimopai.ref.baixo.ref.prox;
                }

            } else {
                if (raiz.ref.prox.ref != null) {
                    raiz.ref.prox.ref.ant = raiz.ref.ant;
                    if (raiz.ref.ant.ref == null && ultimopai != null)
                        ultimopai.ref.baixo = raiz.ref.prox;
                }
                if (raiz.ref.ant.ref != null)
                    raiz.ref.ant.ref.prox = raiz.ref.prox;
            }
        }
    },
    this.search2 = function (raiz, pesquisa, cont) {

        if (raiz.ref == null)
            return null;
        if (raiz.ref.chave == String.fromCharCode(pesquisa.charCodeAt(cont))) {
            if (pesquisa.length == cont + 1) {
                if (raiz.ref.fimChave == true)
                    return raiz;
                else
                    return null;
            } else
                return this.search2(raiz.ref.baixo, pesquisa, cont + 1);

        } else if (raiz.ref.chave > String.fromCharCode(pesquisa.charCodeAt(cont)))
            return this.search2(raiz.ref.prox, pesquisa, cont);
        else
            return null;

    },
    this.search = function (pesquisa) {
        return this.search2(this.raiz, pesquisa, 0);
    };

}

deslocarRamificacao = function (raiz, dx, time) {
    var speed = getSpeed();
    if (raiz.ref != null)
    {
        var pos = {left: parseInt(document.getElementById(raiz.ref.id).style.left), top: parseInt(document.getElementById(raiz.ref.id).style.top)};
        Plumb.moveTo(raiz.ref.id, pos.left + dx, pos.top,1000 * speed + time * speed);

        deslocarRamificacao(raiz.ref.baixo, dx, time + 100);
        deslocarRamificacao(raiz.ref.prox, dx, time);
    }
},

(function () {
    var collection = new Trie();

    var
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:"Top"});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:[1, 0.8, 0, -1]});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:"Bottom"});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:[0, 0.8, 0, 1]});
    },
    prepare5 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:[0, 0.2, 0, 1]});
    },
    prepare6 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:[1, 0.2, 0, -1]});
    },
    connectDisc = function (pai, elem) {
        Plumb.conectar(prepare3(pai.id), prepare(elem.id));
    },
    connectDiscToRight = function (pai, elem) {
        Plumb.conectar(prepare2(pai.id), prepare4(elem.id));
    },
    connectDiscToLeft = function (pai, elem) {
        Plumb.conectar(prepare6(pai.id), prepare5(elem.id));
    },
    connectDisc2 = function (elem1, elem2) {
        connectDiscToLeft(elem1, elem2);
        connectDiscToRight(elem1, elem2);
    },
    disconnect = function (elem, target) {

        if (elem != null && target != null) {
            Plumb.desconectar({source: elem.id, target: target.id});
            Plumb.desconectar({target: elem.id, source: target.id});
        }
    },

    animationAdd = function (info) {
        UI.lock();

        var speed = getSpeed();
        var raiz = collection.raiz;
        var pos = {left: 100, top: 150};
        var pai = null;
        var ant = null;
        var contdesloc = 0;
        var needdeslocj = [];
        var needdesloc = [];
        var aux = 0;
        var j = 0;

        while (raiz.ref !== null && j < info.length) {
            pos = {left: parseInt(raiz.ref.d.style.left), top: parseInt(raiz.ref.d.style.top)};

            if (info[j].valor === raiz.ref.chave) {
                if (raiz.ref.prox.ref !== null) {
                    needdeslocj[contdesloc] = j;
                    needdesloc[contdesloc] = raiz.ref.prox;
                    contdesloc++;
                }
                j++;
                pai = raiz;
                raiz = raiz.ref.baixo;
                ant = null;
            } else if (info[j].valor > raiz.ref.chave) {
                pai = null;
                ant = raiz;
                raiz = raiz.ref.prox;
            } else {
                aux = 1;
                break;
            }

        }


        if (raiz.ref !== null) {
            if (j === info.length)
                j--;
        } else if (pai === null) {
            pos.left += 80;
            pos.top -= 70;
        }

        if (collection.raiz.ref !== null)
            descartarChar(info, collection.raiz, 0, j);

        setTimeout(function () {

            if (j === info.length) {
                UI.unlock();
                window.Eprogramada.nextQueue();
                return;
            }

            setTimeout(function (){

                if (!(raiz.ref !== null && aux === 0)) {
                    for (var i = 0; i < contdesloc; i++)
                        if (needdeslocj[i] + altura(needdesloc[i]) >= j)
                            deslocarRamificacao(needdesloc[i], 80, 0);
                }
                if (raiz.ref !== null) {

                    if (aux === 0) {
                        Plumb.moveTo(info[j].id, pos.left, pos.top, 2000 * speed);
                        setTimeout(function () {
                            $("#" + info[j].id).remove();
                            pai.ref.d.className = "smallbigdot2";
                            collection.insere(info);
                            UI.unlock();
                            window.Eprogramada.nextQueue();
                        }, 2000 * speed);
                    } else {
                        pos.top -= 70;
                        animationAddNo(j, info, pos, -1);

                        deslocarRamificacao(raiz, 80, 0);

                        if (ant != null)
                            disconnect(ant.ref, raiz.ref);
                        if (pai != null)
                            disconnect(pai.ref, raiz.ref);

                        setTimeout(function () {

                            if (pai != null)
                                connectDisc(pai.ref, info[j]);

                            connectDisc2(info[j], raiz.ref);

                            if (raiz.ref.ant.ref != null)
                                connectDisc2(raiz.ref.ant.ref, info[j]);

                            collection.insere(info);
                            UI.unlock();
                            window.Eprogramada.nextQueue();

                        }, (info.length - j) * 2000 * speed + 3000 * speed);
                    }
                } else {
                    var dx = 0;

                    if (ant != null) {

                        var auxpointer = ant.ref.baixo;

                        var dy = 1;

                        while (auxpointer.ref != null) {
                            if (dy < j)
                                dy++;

                            if (auxpointer.ref.prox.ref != null) {
                                var d = 0;
                                var aux3 = auxpointer.ref.prox;

                                while (aux3.ref != null) {
                                    while (aux3.ref.prox.ref == null && aux3.ref.baixo.ref != null)
                                        aux3 = aux3.ref.baixo;

                                    aux3 = aux3.ref.prox;
                                    d++;

                                }

                                dx += d;
                            }
                            auxpointer = auxpointer.ref.baixo;
                        }

                    }

                    if (dx != 0)
                        pos.left += 80 * dx;

                    animationAddNo(j, info, pos, -1);

                    setTimeout(function () {
                        if (ant != null)
                            connectDisc2(ant.ref, info[j]);

                        if (pai != null)
                            connectDisc(pai.ref, info[j]);

                        collection.insere(info);
                        UI.unlock();
                        window.Eprogramada.nextQueue();

                    }, (info.length - j) * 2000 * speed + 3000 * speed);

                }
            }, j * 2000 * speed + 1000 * speed);

        }, (collection.raiz.ref != null ? 1000 * speed + Max(2000 * speed * (j - 1), 0) : 0));

    },
    Max = function (a, b) {
        return (a > b ? a : b);
    },
    altura = function (raiz) {
        if (raiz.ref != null)
            return altura(raiz.ref.baixo) + 1;

        return -1;
    },

    descartarChar = function (info, raiz, i, j) {
        var speed = getSpeed();
        if(raiz.ref===null)
            return;
        if (i < info.length) {

            setTimeout(function () {

                var aux = raiz.ref.d.className;
                var auxref = raiz.ref;
                setTimeout(function () {
                    if (aux != "searchdotnext" && i != j) {
                        $("#" + info[i].id).fadeOut(600 * speed);
                        setTimeout(function () {
                            $("#" + info[i].id).remove();
                        }, 600 * speed);
                    }

                    auxref.d.className = aux;
                    info[i].d.className = aux;

                }, 2000 * speed);

                if (raiz.ref.chave == info[i].valor) {

                    raiz.ref.d.className = "searchdot";

                    if (i + 1 == info.length) {

                        if (raiz.ref.fimChave == false)
                            raiz.ref.d.className = "searchdot2";

                    } else {

                        if (raiz.ref.baixo.ref == null)
                            raiz.ref.d.className = "searchdot2";

                        else
                            descartarChar(info, raiz.ref.baixo, i + 1, j);

                    }

                } else if (info[i].valor > raiz.ref.chave) {

                    while (raiz.ref !== null && info[i].valor > raiz.ref.chave)
                        raiz = raiz.ref.prox;

                    if (raiz.ref !== null)
                        descartarChar(info, raiz, i, j);

                } else
                    raiz.ref.d.className = "searchdot2";


                info[i].d.className = aux;

            }, (i != 0 ? 2000 * speed : 0));

        }

    },

    animationAddNo = function (j, info, pos, pai) {
        var speed = getSpeed();

        if (j < info.length) {
            setTimeout(function () {

                pos.top += 70;
                Plumb.moveTo(info[j].id, pos.left, pos.top, 2000 * speed);

                if (pai != -1)
                    setTimeout(function () {
                        connectDisc(info[pai], info[j]);
                    }, 2000 * speed);


                animationAddNo(j + 1, info, pos, j);

            }, 2000 * speed);
        }

    },
    animationDot = function (raiz, info, i) {

        var speed = getSpeed();

        if (i < info.length) {

            setTimeout(function () {

                var aux = raiz.ref.d.className;

                setTimeout(function () {
                    if (raiz.ref.d.className != "searchdotnext") {
                        $("#" + info[i].id).fadeOut(600 * speed);
                        setTimeout(function () {
                            $("#" + info[i].id).remove();
                        }, 600 * speed);
                    }
                    if (raiz.ref.d.className == "searchdot2") {
                        for (j = i + 1; j < info.length; j++)
                            $("#" + info[j].id).fadeOut(600 * speed);

                        UI.unlock();
                    }
                    raiz.ref.d.className = aux;

                }, 2000 * speed);

                if (raiz.ref.chave == info[i].valor) {
                    raiz.ref.d.className = "searchdot";

                    if (i + 1 == info.length) {
                        if (raiz.ref.fimChave == false)
                            raiz.ref.d.className = "searchdot2";
                        else
                            setTimeout(function () {
                                UI.unlock();
                            }, 2000 * speed);
                    } else {
                        if (raiz.ref.baixo.ref == null)
                            raiz.ref.d.className = "searchdot2";
                        else
                            animationDot(raiz.ref.baixo, info, i + 1);
                    }

                } else if (info[i].valor > raiz.ref.chave) {
                    if (raiz.ref.prox.ref != null) {
                        raiz.ref.d.className = "searchdotnext";
                        animationDot(raiz.ref.prox, info, i);
                    } else
                        raiz.ref.d.className = "searchdot2";

                } else
                    raiz.ref.d.className = "searchdot2";


                info[i].d.className = raiz.ref.d.className;

            }, (i != 0 ? 2000 * speed : 0));

        }

    },
    animationSearch = function (info) {

        UI.lock();
        var raiz = collection.raiz;

        animationDot(raiz, info, 0, null);

    },
    animationRem = function (raiz, info, i, ultimo, ultimopai) {

        var speed = getSpeed();
        if (i < info.length) {

            setTimeout(function () {

                var aux = raiz.ref.d.className;

                setTimeout(function () {
                    if (raiz.ref.d.className != "searchdotnext")
                        $("#" + info[i].id).fadeOut(600 * speed);

                    if (raiz.ref.d.className == "searchdot2") {
                        for (j = i + 1; j < info.length; j++)
                            $("#" + info[j].id).fadeOut(600 * speed);

                        UI.unlock();
                        window.Eprogramada.nextQueue();
                    }
                    raiz.ref.d.className = aux;

                }, 2000 * speed);

                if (raiz.ref.chave == info[i].valor) {
                    raiz.ref.d.className = "searchdot";

                    if (i + 1 == info.length) {
                        if (raiz.ref.fimChave == false)
                            raiz.ref.d.className = "searchdot2";
                        else
                            setTimeout(function () {

                                if (raiz.ref.baixo.ref != null)
                                    raiz.ref.d.className = "dinamicSmallDot";

                                else {
                                    var saveultimo = ultimo;

                                    if (raiz.ref.prox.ref == null && raiz.ref.ant.ref == null) {

                                        var proximo = ultimo.ref.prox;
                                        var anterior = ultimo.ref.ant;
                                        var ant = ultimo;
                                        ultimo = ultimo.ref.baixo;

                                        disconnect(anterior.ref, ant.ref);
                                        disconnect(proximo.ref, ant.ref);

                                        if (proximo.ref != null && anterior.ref != null) {
                                            connectDisc2(anterior.ref, proximo.ref);
                                            deslocarRamificacao(proximo, -80, 0, 0);
                                        } else if (proximo.ref != null && anterior.ref == null && ultimopai != null) {
                                            disconnect(ultimopai.ref, ant.ref);
                                            deslocarRamificacao(proximo, -80, 0, 0);
                                            connectDisc(ultimopai.ref, proximo.ref);
                                        }

                                        if (ant.ref.fimChave == true) {
                                            disconnect(ant.ref, ultimo.ref);
                                            ant = ultimo;
                                            ultimo = ultimo.ref.baixo;
                                        }

                                        while (ultimo != raiz) {
                                            disconnect(ant.ref, ultimo.ref);
                                            $("#" + ant.ref.id).remove();
                                            ant = ultimo;
                                            if (ultimo.ref != null)
                                                ultimo = ultimo.ref.baixo;
                                            else
                                                break;
                                        }

                                        if (ultimo.ref != null) {
                                            disconnect(ant.ref, ultimo.ref);
                                            $("#" + ant.ref.id).remove();
                                            $("#" + ultimo.ref.id).remove();
                                        }
                                    } else {
                                        proximo = raiz.ref.prox;
                                        anterior = raiz.ref.ant;

                                        disconnect(anterior.ref, raiz.ref);
                                        disconnect(proximo.ref, raiz.ref);

                                        if (proximo.ref != null && anterior.ref != null) {
                                            connectDisc2(anterior.ref, proximo.ref);
                                            deslocarRamificacao(proximo, -80, 0, 0);
                                        } else if (proximo.ref != null && anterior.ref == null && ultimopai != null) {
                                            disconnect(ultimopai.ref, ultimopai.ref.baixo.ref);
                                            deslocarRamificacao(proximo, -80, 0, 0);
                                            connectDisc(ultimopai.ref, proximo.ref);
                                        }

                                        $("#" + raiz.ref.id).remove();

                                    }
                                }

                                collection.remove(raiz, saveultimo, ultimopai);
                                UI.unlock();
                                window.Eprogramada.nextQueue();

                            }, 2000 * speed);
                    } else {
                        if (raiz.ref.baixo.ref == null)
                            raiz.ref.d.className = "searchdot2";
                        else {
                            if (raiz.ref.fimChave == true || raiz.ref.prox.ref != null)
                                animationRem(raiz.ref.baixo, info, i + 1, raiz, ultimopai);
                            else {
                                if (raiz.ref.baixo.ref.prox.ref != null)
                                    animationRem(raiz.ref.baixo, info, i + 1, ultimo, raiz);
                                else
                                    animationRem(raiz.ref.baixo, info, i + 1, ultimo, ultimopai);
                            }
                        }
                    }

                } else if (info[i].valor > raiz.ref.chave) {
                    if (raiz.ref.prox.ref != null) {
                        raiz.ref.d.className = "searchdotnext";
                        animationRem(raiz.ref.prox, info, i, raiz.ref.prox, ultimopai);
                    } else
                        raiz.ref.d.className = "searchdot2";

                } else
                    raiz.ref.d.className = "searchdot2";

                info[i].d.className = raiz.ref.d.className;

            }, 2000 * speed);

        }

    },
    animationRemove = function (info) {

        UI.lock();
        var raiz = collection.raiz;

        animationRem(raiz, info, 0, raiz, null);

    },
    createDisc = function (value) {
       var elem = Element.createElement(
                {className:"dinamicSmallDot",
                innerHTML:"<span class='itemValue' style='top:7px'>" + value + "</span>",
                left:"30px",
                top:"150px",
                idParent:"main"});
        $("#"+elem.id).hide();
        $("#"+elem.id).fadeIn(600*getSpeed());
        elem.valor = value;
        return elem;
    },
    createDiscFinal = function (value) {
       var elem = Element.createElement(
                {className:"smallbigdot2",
                innerHTML:"<span class='itemValue' style='top:7px'>" + value + "</span>",
                left:"30px",
                top:"150px",
                title:value,
                idParent:"main"});
        $("#"+elem.id).hide();
        $("#"+elem.id).fadeIn(600*getSpeed());
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            collection.inicia();
            UI.InitInterface(this.search);
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor');
                if (value !== "") {
                    var speed = getSpeed();
                    var info = [];

                    for (var i = value.length - 1; i >= 0; i--)  {
                        if (i + 1 !== value.length)
                            info[i] = createDisc(String.fromCharCode(value.charCodeAt(i)));
                        else
                            info[i] = createDiscFinal(String.fromCharCode(value.charCodeAt(i)));

                        Plumb.moveTo(info[i].id, 30,150 + 70 * i, 400 * speed + 200 * i * speed);

                        Plumb.tornarArrastavel(info[i].id);
                    }
                    UI.subtitle("Inserindo a palavra \"<b>"+value+"</b>\"");
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }

        },
        removeValue: function () {

            var value = UI.value('valor');

            if (value !== "") {
                var speed = getSpeed();
                var info = [];

                for (var i = value.length - 1; i >= 0; i--) {
                    if (i + 1 !== value.length)
                        info[i] = createDisc(String.fromCharCode(value.charCodeAt(i)));
                    else
                        info[i] = createDiscFinal(String.fromCharCode(value.charCodeAt(i)));

                    Plumb.moveTo(info[i].id, 30,150 + 70 * i, 400 * speed + 200 * i * speed);
                }
                UI.subtitle("Removendo a palavra \"<b>"+value+"</b>\"");
                animationRemove(info);
            }

        },
        searchValue: function () {

            var value = UI.value('valor');

            if (value !== "") {
                
                var speed = getSpeed();
                var info = [];
                for (var i = value.length - 1; i >= 0; i--) {
                    if (i + 1 !== value.length)
                        info[i] = createDisc(String.fromCharCode(value.charCodeAt(i)));
                    else
                        info[i] = createDiscFinal(String.fromCharCode(value.charCodeAt(i)));

                    Plumb.moveTo(info[i].id, 30,150 + 70 * i, 600 * speed);

                }
                UI.subtitle("Buscando a palavra \"<b>"+value+"</b>\"");
                setTimeout(function () {
                    animationSearch(info);
                }, 1400 * speed + 200 * (value.length - 1) * speed);
            }
        }
    };
})();
