jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function FilaPrioridade() {
    this.ini = null;
    this.fim = null;

    FilaPrioridade.criaNo = function () {
        return {
            valor: null,
            dado: null,
            prioridade: null,
            ant: null,
            prox: null
        };
    };

    this.insere = function (valor, dado, prioridade) {
        var novo = FilaPrioridade.criaNo();

        novo.valor = valor;
        novo.dado = dado;
        novo.prioridade = prioridade;
        Element.bind(novo,dado.id);
        var aux = this.ini;
        var ant = null;
        var pos = 0;

        while (aux && aux.prioridade * 1 < prioridade * 1) {
            pos++;
            ant = aux;
            aux = aux.prox;
        }

        if (aux) {
            if (!ant) {
                novo.prox = this.ini;
                this.ini.ant = novo;
                this.ini = novo;
            } else {
                novo.prox = aux;
                novo.ant = ant;
                ant.prox = novo;
                aux.ant = novo;
            }
        } else {
            if (!ant)
                this.ini = novo;
            else {
                this.fim.prox = novo;
                novo.ant = this.fim;
            }
            this.fim = novo;
        }
        return(pos);
    };

    this.remove = function () {
        if (this.fim) {
            this.fim = this.fim.ant;
            if (!this.fim)
                this.ini = null;
            else
                this.fim.prox = null;
        }
    };

    this.busca = function (dado) {
        var aux = this.ini;
        var i = 0;

        while (aux && aux.valor * 1 != dado * 1) {
            aux = aux.prox;
            i--;
        }

        if (aux && aux.valor * 1 == dado * 1)
            return i;
        return -1;
    };

    this.at = function (i) {
        var no = this.ini;

        while (no && i) {
            no = no.prox;
            i--;
        }

        return no.dado;
    };

}

(function () {
    var collection = new FilaPrioridade();
    var lastPosIns;

    var 
    setInitial = function(elId,key,text){
        $("#"+elId).find("span.initial").remove();
        if(key){
            $("#"+elId).append("<span class='initial' style='margin-top:14px'>"+text+"</span>");
        }
    },
    setFinal = function(elId,key){
        $("span.final").remove();
        if(key){
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    deslocar = function(dados,offsetX,time){
      Plumb.moveTo(dados.id,parseInt(dados.d.style.left)+offsetX,parseInt(dados.d.style.top),time);  
    },
    deslocarApartir = function(raiz,offsetX,time){
        while(raiz!==null) {
            deslocar(raiz.dado,offsetX,time);
            raiz = raiz.prox;
        }
    },
    animationAdd = function (elId, prior) {
        UI.lock();

        var speed = getSpeed();
        var posFim = {left: 100, top: screen.height / 2.5};
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(0,4,50);
        if (collection.ini.prox!==null) {
            var i=1, pos;
            var elem = collection.ini;
            while(elem.prioridade!==prior){
                var looptime = (i-1)*2000 + 1000;
                pos = {left: parseInt(elem.dado.d.style.left), top: parseInt(elem.dado.d.style.top)};
                posFim = {left: pos.left + 125, top: pos.top};
                Plumb.moveTo(elId,pos.left,pos.top - 60, 2000 * speed);

                highlighter.line(5,looptime);
                highlighter.line(7,looptime+500);
                highlighter.line(8,looptime+1000);
                i++;
                elem = elem.prox;
            }
            setTimeout(function () {
                highlighter.clear(500);
                highlighter.lineRed(5,500);
                if (elem.prox!==null) {
                    highlighter.line(10,900);
                    if(elem.ant===null){
                        highlighter.line(12,1200);
                        highlighter.lines(14,16,1600);
                    } else {
                        highlighter.line(18,1200);
                        highlighter.lineRed(12,1200);
                        highlighter.lines(20,23,1600);
                    }
                    deslocarApartir(elem.prox,125,2000*speed);   
                } else {
                    highlighter.line(26,900);
                    highlighter.lineRed(10,900);
                    if(elem.ant===null){
                        highlighter.line(28,1200);
                        highlighter.line(29,1500);
                    } else {
                        highlighter.line(30,1200);
                        highlighter.lineRed(28,1200);
                        highlighter.lines(32,33,1500);
                    }
                    highlighter.line(35,1750);
                }
                highlighter.clear(2000);
                setTimeout(function(){
                    connectDisc(elem);
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                }, 2000 * speed);
            }, (i-1) * 2000 * speed);
        } else {
            highlighter.clear(500);
            highlighter.lineRed(5,500);
            highlighter.line(26,1000);
            highlighter.lineRed(10,1000);
            highlighter.line(28,1300);
            highlighter.line(29,1600);
            highlighter.clear(2000);
            setTimeout(function(){
                setInitial(elId,true,"<p>Fila.inicio</p><p>Fila.fim</p>");
                setFinal(elId,true);
                UI.unlock();
                window.Eprogramada.nextQueue();
            },2000*speed);
        }
        Plumb.moveTo(elId,posFim.left,posFim.top,2000*speed);

    },
    animationSearch = function (elem) {
        UI.lock();
        var speed = getSpeed();
        var i = 0;
        var temp = collection.ini;
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.line(0,3,50);

        while(temp!==null){
            var looptime = 2000*i + 1000;
            var pos = {left: parseInt(temp.dado.d.style.left), top: parseInt(temp.dado.d.style.top) - 65};
            Plumb.moveTo(elem.id, pos.left, pos.top, 2000 * speed);
            if (elem.valor == temp.valor)
                break;
            highlighter.line(4,looptime);
            highlighter.clear(looptime+500);
            highlighter.lineRed(6,looptime+500);
            highlighter.line(8,looptime+1000);
            highlighter.line(9,looptime+1500);
            i++;
            temp = temp.prox;
        }

        setTimeout(function () {
            if (temp!==null) {
                highlighter.line(4,50);
                highlighter.line(6,500);
                highlighter.line(7,1000);
                var  obj = $("#" + temp.dado.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            } else {
                highlighter.clear(50);
                highlighter.lineRed(4,50);
                highlighter.line(11,1000);
                Plumb.moveTo(elem.id, pos.left+125, pos.top, 2000 * speed);
            }
            highlighter.clear(2000);
            $("#" + elem.id).fadeOut(1000 * speed);
            UI.unlock();
            setTimeout(function(){
                $("#" + elem.id).remove();
            },2000*speed);
        }, (i + 1) * 2000 * speed);

    },
    animationRemove = function () {
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        if (collection.ini!==null) {
            highlighter.line(0,50);
            highlighter.lines(2,5,500);
            UI.lock();
            
            if(collection.ini.ant===null){
                highlighter.line(6,1000);
                highlighter.line(7,1500);
            } else {
                highlighter.line(6,1000);
                highlighter.lineRed(8,1000);
                highlighter.line(9,1500);
            }
            highlighter.line(10,2000);
            highlighter.line(11,2500);
            highlighter.clear(3000);
            var obj = $("#" + collection.fim.dado.id);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);

            setTimeout(function () {
                disconnectDisc(collection.fim);
                setTimeout(function () {
                    obj.remove();
                    collection.remove();
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                }, 1000 * speed);
            }, 5500 * speed);
            
        } else {
            highlighter.lineRed(0,50);
            highlighter.clear(1000);
            highlighter.line(13,1000);
            highlighter.clear(2000);
            setTimeout(function () {
                window.Eprogramada.nextQueue();
            }, 2000 * speed);
        }

    },

    prepareAnt = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[1, 0.3, 0, -1],isSource:false,isTarget:true,isPrimary:true});
    },
    prepareProx = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[0, 0.3, 0, -1],isSource:true,isTarget:false,isPrimary:true});
    },
    prepareAnt2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[0, 0.7, 0, -1],isSource:false,isTarget:true,isPrimary:false});
    },
    prepareProx2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{anchor:[1, 0.7, 0, -1],isSource:true,isTarget:false,isPrimary:false});
    },
    connectDisc = function (elem) {
        
        if(collection.ini.prox.prox===null) {
            setInitial(collection.ini.dado.id,true,"Fila.inicio");
            setInitial(collection.ini.prox.dado.id,true,"Fila.fim");
            setFinal(collection.ini.prox.dado.id,true);
        } else if(elem===collection.ini) {
            setInitial(collection.ini.prox.dado.id,false);
            setInitial(collection.ini.dado.id,true,"Fila.inicio");
        } else if(elem.prox===null){
            setInitial(elem.ant.dado.id,false);
            setInitial(elem.dado.id,true,"<p>Fila.fim</p>");
            setFinal(elem.dado.id,true);
        }
        
        if(elem.ant!==null && elem.prox!==null){
            Plumb.desconectar({source:elem.ant.dado.id,target:elem.prox.dado.id});
            Plumb.desconectar({target:elem.ant.dado.id,source:elem.prox.dado.id});
        }
        if(elem.ant!==null) {
            Plumb.conectar(prepareAnt(elem.ant.dado.id),prepareProx(elem.dado.id));
            Plumb.conectar(prepareAnt2(elem.dado.id),prepareProx2(elem.ant.dado.id));
        }
        if(elem.prox!==null) {
            Plumb.conectar(prepareAnt(elem.dado.id),prepareProx(elem.prox.dado.id));
            Plumb.conectar(prepareAnt2(elem.prox.dado.id),prepareProx2(elem.dado.id));
        }
    },
    disconnectDisc = function (elem) {
        Plumb.desconectarCompletamente(elem.dado.id);
        setInitial(elem.dado.id,false);
        if(collection.ini === elem.ant) {
            setInitial(elem.ant.dado.id,true,"<p>Fila.inicio</p><p>Fila.fim</p>");
        } else {
            if(elem.ant!==null)
                setInitial(elem.ant.dado.id,true,"<p>Fila.fim</p>");
        }
        if(elem.ant!==null)
            setFinal(elem.ant.dado.id,true);
    },
    createDisc = function (value, prior) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValuePriori altColorTitle'>" + value + "</span><span class='itemPriori altColor1 altColorTitle1'>"+prior+"</span>",
            left:"100px",
            top:"75px",
            title: value+"/"+prior,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.setProperty("primaryColorProperty",true);
            UI.setProperty("secondaryColorProperty",true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.AddInput("prioridade");
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.valor,'prioridade':element.prioridade};
                if (element.prox !== null) {
                    var nextId = (element.prox.dado.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.dado.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            var prior = UI.value('prioridade');
            if(value!==""){
                return $(".dinamicDot[title='"+value+"/"+prior+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()) {
                var value = UI.value('valor');
                var prior = UI.value('prioridade',"Prioridade deve ser um numero!");
                if ((value !== "") && (prior !== "")) {
                    var info = createDisc(value, prior);
                    lastPosIns = collection.insere(value, info, prior);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info.id, prior);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b> com prioridade <b>"+prior+"</b>");
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            UI.subtitle("Removendo o primeiro da fila");
            animationRemove();
        },
        searchValue: function () {
            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                $("#" + info.id).html("<span class='itemValue'>" + value + "</span>");
                animationSearch(info);
            }

        }

    };
})();