jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function HashSemColisao() {
    this.MAX = 10;
    this.tabelaHash = new Array(this.MAX);

    HashSemColisao.criaNo = function () {
        return {ref: null, id: null, value: null, prox: null, ant: null};
    };

    this.inicia = function (MAX) {
        this.MAX = MAX || this.MAX;
        for (var i = 0; i < this.MAX; ++i)
            this.tabelaHash[i] = null;
    };

    this.hashFunction = function (chave) {
        var qtd = chave.length;
        var soma = 0;

        for (var i = 0; i < qtd; ++i)
            soma += (i + 1) * chave.charCodeAt(i);
        return soma % this.MAX;
    };

    this.insere = function (elem) {
        var ind = this.hashFunction(elem.valor);
        var novo = HashSemColisao.criaNo();

        novo.prox = null;
        novo.ant = null;
        novo.ref = elem.d;
        novo.id = elem.id;
        novo.value = elem.valor;
        Element.bind(novo,novo.id);
        if (!this.tabelaHash[ind])
            this.tabelaHash[ind] = novo;
        else {
            var aux = this.tabelaHash[ind], ant = null;

            while (aux && aux.value <= elem.valor) {
                ant = aux;
                aux = aux.prox;
            }

            if (aux) {
                if (ant) {
                    novo.prox = aux;
                    novo.ant = ant;
                    ant.prox = novo;
                    aux.ant = novo;
                } else {
                    novo.prox = this.tabelaHash[ind];
                    this.tabelaHash[ind].ant = novo;
                    this.tabelaHash[ind] = novo;
                }
            } else {
                ant.prox = novo;
                novo.ant = ant;
            }
        }
    };

    this.remove = function (value) {
        var ind = this.hashFunction(value);
        var aux = this.tabelaHash[ind];
        var ant = null;

        while (aux && aux.value < value) {
            ant = aux;
            aux = aux.prox;
        }

        if (aux && aux.value == value) {
            if (!ant) {
                this.tabelaHash[ind] = this.tabelaHash[ind].prox;
                if (this.tabelaHash[ind])
                    this.tabelaHash[ind].ant = null;
            } else {
                ant.prox = aux.prox;
                if (aux.prox)
                    aux.prox.ant = aux.ant;
            }
        }
    };

}

(function () {
    var collection = new HashSemColisao();
    var pointerDots = new Array(collection.MAX);

    var 
    deslocarApartir = function(raiz,offsetX,time){
        while(raiz!==null){
            deslocar(raiz,offsetX,time);
            raiz = raiz.prox;
        }
    },
    deslocar = function(raiz,offsetX,time){
        Plumb.moveTo(raiz.id,parseInt(raiz.ref.style.left)+offsetX,parseInt(raiz.ref.style.top),time);
    },
    animationAddList = function (info, ind) {
        var speed = getSpeed();
        var pos = {left: 705, top: 75 + (ind * 52)};
        var cabeca = collection.tabelaHash[collection.hashFunction(info.valor)];
        var anterior = pointerDots[ind];
        var i = 0;
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        Plumb.moveTo(info.id,pos.left,pos.top,2000*speed);

        if(cabeca == null) {
            highlighter.line(5,5000);
            highlighter.line(6,6000);
            highlighter.clear(7000);
        } else {
            highlighter.lineRed(5,5000);
            highlighter.line(7,5000);
            highlighter.line(9,5500);
            highlighter.line(10,6000);

            while (cabeca != null) {
                i++;
                highlighter.line(11,i*2000+4000);
                highlighter.line(13,i*2000+4500);
                highlighter.line(14,i*2000+5000);
                pos = {left: parseInt(cabeca.ref.style.left), top:  75 + (ind * 52)};

                if (cabeca.value > info.valor)
                    break;
                Plumb.moveTo(info.id,pos.left + 75,pos.top,2000 * speed);
                anterior = cabeca;
                cabeca = cabeca.prox;
            }

            highlighter.lineRed(11,i*2000+6000);
            if(cabeca === null) {
                highlighter.lineRed(16,i*2000+6500);
                highlighter.line(32,i*2000+7000);
                highlighter.line(34,i*2000+7500);
                highlighter.line(35,i*2000+8000);
                highlighter.clear(i*2000+9000);
            } else {
                highlighter.line(16,i*2000+6500);
                if(anterior!==null) {
                    highlighter.line(18,i*2000+7000);
                    highlighter.lines(20,23,i*2000+8000);
                    highlighter.clear(i*2000+9000);
                } else {
                    highlighter.lineRed(18,i*2000+7000);
                    highlighter.line(25,i*2000+7000);
                    highlighter.lines(27,29,i*2000+8000);
                    highlighter.clear(i*2000+9000);
                }
            }
        }

        setTimeout(function () {
            if (cabeca != null) {
                var temp = cabeca;
                deslocarApartir(cabeca,75,2000*speed);

                connectDisc(info, anterior, temp, true);
            } else {
                connectDisc(info, pointerDots[ind], anterior, false);
            }

            setTimeout(function () {
                collection.insere(info);
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 2000 * speed);

        }, i * 2000 * speed + 4000 * speed);

    },

    animationAdd = function (info) {
        UI.lock();
        var speed = getSpeed();
        var pos = {left: 295, top: 255};
        var ind = collection.hashFunction(info.valor);
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        
        highlighter.line(0,1000);
        highlighter.lineGreen(1,2000);
        highlighter.line(2,2600);
        highlighter.line(3,3200);
        highlighter.line(4,4000);

        Plumb.moveTo(info.id, pos.left, pos.top,2000 * speed);
        pos = {left: 5+ 700, top: 75 + (ind * 52)};
        Plumb.moveTo(info.id, pos.left, pos.top,  2000 * speed);

        animationAddList(info, ind);
    },

    animationSearchList = function (info, ind) {
        var pos = {left: 705 ,top: 75 + (ind * 52)};
        var cabeca = collection.tabelaHash[collection.hashFunction(info.valor)];
        var i = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        Plumb.moveTo(info.id,pos.left, pos.top, 2000 * speed);

        while (cabeca != null) {

            i++;
            highlighter.line(4,i*2000+2000);

            pos = {left: parseInt(cabeca.ref.style.left),top: 75 + (ind * 52)};
            if (cabeca.value >= info.valor)
                break;
            Plumb.moveTo(info.id,pos.left + 80,pos.top,2000*speed);
            highlighter.clear(i*2000+2700);
            highlighter.lineRed(6,i*2000+2800);
            highlighter.line(8,i*2000+3600);
            cabeca = cabeca.prox;
        }

        if(cabeca===null){
            highlighter.clear(i*2000+2500);
            highlighter.lineRed(4,i*2000+2600);
            highlighter.clear(i*2000+3100);
            highlighter.lineRed(10,i*2000+3200);
            highlighter.clear(i*2000+4000);
        } else if(cabeca.value === info.valor) {
            highlighter.line(6,i*2000+2600);
            highlighter.line(7,i*2000+3200);
            highlighter.clear(i*2000+4000);
        } else {
            highlighter.clear(i*2000+2500);
            highlighter.lineRed(4,i*2000+2600);
            highlighter.clear(i*2000+3100);
            highlighter.lineRed(10,i*2000+3200);
            highlighter.clear(i*2000+4000);
        }

        setTimeout(function () {
            var objInfo = $("#" + info.id);
            objInfo.fadeOut(1000 * speed);

            if (cabeca != null && cabeca.value == info.valor) {
                var obj = $("#" + cabeca.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }

            setTimeout(function () {
                UI.unlock();
                objInfo.remove();
            }, 1200 + (cabeca != null && cabeca.value == info.valor) ? 6000 * speed : 0);

        }, (i + 2) * 2000 * speed);
    },
    animationSearch = function (info) {
        UI.lock();
        var speed = getSpeed();
        var pos = {left: 295, top: 250};
        var ind = collection.hashFunction(info.valor);
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.line(0,100);
        highlighter.line(1,1000);
        highlighter.lineGreen(2,2000);
        highlighter.line(3,3000);

        Plumb.moveTo(info.id, pos.left, pos.top, 2000 * speed);
        pos = {left: 705, top: 80 + (ind * 52)};
        Plumb.moveTo(info.id, pos.left, pos.top, 2000 * speed);

        animationSearchList(info, ind);
    },
    animationRemoveList = function (info, ind) {
        var speed = getSpeed();
        var pos = {left: 705,top: 75 + (ind * 52)};
        var cabeca = collection.tabelaHash[collection.hashFunction(info.valor)];
        var i = 0;
        
        Plumb.moveTo(info.id, pos.left, pos.top, 2000 * speed);

        while (cabeca != null) {
            i++;

            pos = {left: parseInt(cabeca.ref.style.left),top: 75 + (ind * 52)};
            if (cabeca.value >= info.valor)
                break;
            Plumb.moveTo(info.id, pos.left + 80, pos.top,  2000 * speed);

            cabeca = cabeca.prox;
        }


        setTimeout(function () {
            var objInfo = $("#" + info.id);
            objInfo.fadeOut(1000 * speed);

            if (cabeca != null && cabeca.value == info.valor) {
                var obj = $("#" + cabeca.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);

                setTimeout(function () {
                    disconnectDisc(cabeca, ind);
                    deslocarApartir(cabeca.prox,-80,2000*speed);
                }, 2000 * speed);

            }

            setTimeout(function () {
                objInfo.remove();
                if(cabeca!==null)
                    $("#" + cabeca.id).remove();
                collection.remove(info.valor);
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 2000 * speed + (cabeca != null && cabeca.value == info.valor ? 8000 * speed : 0));

        }, (i + 2) * 2000 * speed);
    },
    animationRemove = function (info) {
        UI.lock();
        ind = 0;
        var pos = {left: 295, top: 250};
        var ind = collection.hashFunction(info.valor);
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        highlighter.line(0,100);
        highlighter.line(1,1000);
        highlighter.lineGreen(2,2000);
        highlighter.line(3,3000);

        Plumb.moveTo(info.id, pos.left, pos.top, 2000 * speed);
        pos = {left: 705, top: 75 + (ind * 52)};
        Plumb.moveTo(info.id, {left: pos.left, top: pos.top}, {duration: 2000 * speed});

        animationRemoveList(info, ind);

    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:"Right"});
    },
    prepare1 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:[1, 0.8, 0, -1]});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:[0, 0.8, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:[1, 0.2, 0, -1]});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:[0, 0.2, 0, -1]});
    },
    connectDisc = function (novo, elemAnterior, elem, ehCabeca) {
        if (ehCabeca && elem != null) {

            var connections = jsPlumb.getConnections({target: elem.id});
            if (connections[0] !== undefined)
                jsPlumb.detach(connections[0]);
            if (elem.ant !== null) {
                if (connections[1] !== undefined)
                    jsPlumb.detach(connections[1]);
            }
            
            Plumb.conectar(prepare1(novo.id), prepare2(elem.id));
            Plumb.conectar(prepare4(novo.id), prepare3(elem.id));

            if (elemAnterior == elem.ant) {
                Plumb.conectar(prepare4(elemAnterior.id),prepare3(novo.id));
                Plumb.conectar(prepare1(elemAnterior.id),prepare2(novo.id));
            } else {
                Plumb.conectar(prepare(elemAnterior.id),prepare2(novo.id));
            }

        } else {
            if (elemAnterior != elem) {
                Plumb.conectar(prepare4(elem.id),prepare3(novo.id));
                Plumb.conectar(prepare1(elem.id),prepare2(novo.id));
            } else {
                Plumb.conectar(prepare(elemAnterior.id),prepare2(novo.id));
            }
        }

    },

    disconnectDisc = function (elem, ind) {

        if (elem.ant == null) {
            var connections = jsPlumb.getConnections({source: elem.id});
            jsPlumb.detach(connections[0]);
            if (elem.prox != null) {
                connections = jsPlumb.getConnections({target: elem.prox.id});
                jsPlumb.detach(connections[0]);
                connections = jsPlumb.getConnections({target: elem.id});
                var auxid = connections[0].sourceId;
                jsPlumb.detach(connections[0]);
                Plumb.conectar(prepare1(auxid),prepare2(elem.prox.id));

            }
        } else if (elem.prox == null) {
            var connections = jsPlumb.getConnections({target: elem.id});
            jsPlumb.detach(connections[0]);
            connections = jsPlumb.getConnections({source: elem.ant.id});
            jsPlumb.detach(connections[0]);
        } else {
            var connections = jsPlumb.getConnections({target: elem.id});
            jsPlumb.detach(connections[0]);
            jsPlumb.detach(connections[1]);

            connections = jsPlumb.getConnections({source: elem.id});
            jsPlumb.detach(connections[0]);
            jsPlumb.detach(connections[1]);
            Plumb.conectar(prepare4(elem.ant.id),prepare3(elem.prox.id));
            Plumb.conectar(prepare1(elem.ant.id),prepare2(elem.prox.id));
        }

    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicSmallDot altColor",
            innerHTML:"<span class='itemValue altColorTitle' style='top: 8px'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    createPointerDot = function (top, left, radius) {
        var elem = Element.createElement(
            {className:"dotPointer",
            innerHTML:"",
            left:left,
            top:top,
            idParent:"main"});
        $(elem.d).css("border-radius", radius);
        elem.conecDir = null;
        elem.conecBaixo = null;
        return elem;
    },
    populateDotArray = function () {
        var top = 0;

        for (var i = 0; i < collection.MAX; ++i) {
            pointerDots[i] = createPointerDot((i * 52 + 80 + top) + "px", 622 + "px", "10px 0px 0px 10px");
            prepare(pointerDots[i].id);
        }
    },
    draw = function () {
        Canvas.drawHashTable({canvasId:"canv",total:collection.MAX,alternate:"html"});
    };

    window.Cadilag = {
        init: function () {
            UI.lock();
            Plumb.init(true);
            $("#newStruct").click(this.newStruct);
            UI.setProperty("primaryColorProperty",true);
            UI.InitInterface(this.search,this.elementToString);
            Canvas.initInterface(this.elementIndexToString);
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicSmallDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        newStruct: function(){
            var size = UI.value("sizeArray","Tamanho do Vetor é invalido");
            if(size!=="") {
                UI.setParameters({TAMANHO_DA_TABELA:collection.MAX});
                UI.InitFunctions(Cadilag.addDisc,Cadilag.removeValue,Cadilag.searchValue);
                $("#newStruct").unbind('click');
                collection.inicia(size);
                draw();
                populateDotArray();
                UI.unlock();
                $("#subtopbar").animate({"top":"0px"},500,function(){
                    $(this).remove();
                });
            }
        },
        elementIndexToString: function (index) {
            var element = collection.tabelaHash[index];
            if (element === null) {
                return {'_replaceAll':'null','_index':index,'_title':'TabelaHash'};
            } else if(element !== undefined) {
                var result = {'info':element.value,'_index':index,'_title':'TabelaHash'};
                if (element.prox !== null) {
                    var nextId = (element.prox.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length - 5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        elementToString:function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.value};
                if (element.prox !== null) {
                    var nextId = (element.prox.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length - 5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false; 
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor');
                if (value !== "") {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            var value = UI.value('valor');
            
            if (value !== "") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }

        },
        searchValue: function () {
            var value = UI.value('valor');
            
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }
    };

})();

