jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function ListaCruzada() {
    this.NLINHAS = 10;
    this.NCOLUNAS = 10;
    this.linhas = new Array(this.NLINHAS);
    this.colunas = new Array(this.NCOLUNAS);
    this.numElementos = 0;

    ListaCruzada.criaNo = function () {
        return {info: null, id: null, ref: null, coluna: null, linha: null, dir: null, baixo: null, conecDir: null, conecBaixo: null, endp1: null, endp2: null};
    };

    this.inicia = function (NCOLUNAS,NLINHAS) {
        this.NLINHAS =  parseInt(NLINHAS) || this.NLINHAS;
        this.NCOLUNAS = parseInt(NCOLUNAS) || this.NCOLUNAS ;
        for (var i = 0; i < this.NLINHAS; ++i)
            this.linhas[i] = null;
        for (var i = 0; i < this.NCOLUNAS; ++i)
            this.colunas[i] = null;
        this.numElementos = 0;
    };

    this.busca = function (i, j) {
        if (i < this.NLINHAS && j < this.NCOLUNAS) {
            var aux = this.linhas[i];

            while (aux) {
                if (aux.coluna == j)
                    return aux;
                aux = aux.dir;
            }
        }
        return null;
    };

    this.insere = function (i, j, valor, endp1, endp2) {
        console.log(this.NLINHAS+" "+this.NCOLUNAS);
        console.log(i+" "+j);
        if (!this.busca(i, j) && i < this.NCOLUNAS && j < this.NLINHAS) {
            var novo = ListaCruzada.criaNo();
            if (novo) {
                this.numElementos++;
                novo.linha = i;
                novo.coluna = j;
                novo.info = valor.valor;
                novo.id = valor.id;
                novo.ref = valor.ref;
                novo.endp1 = endp1;
                novo.endp2 = endp2;
                Element.bind(novo,novo.id);
                var coluna, linha;
                var aux1 = this.colunas[j], anterior1 = null,
                        aux2 = this.linhas[i], anterior2 = null;

                if (aux1) {
                    linha = this.colunas[j].linha;

                    while (aux1.baixo && linha < i) {
                        anterior1 = aux1;
                        aux1 = aux1.baixo;
                        linha = aux1.linha;
                    }

                    if (aux1.baixo || (!aux1.baixo && linha > i)) {
                        if (!anterior1) {
                            novo.baixo = aux1;
                            this.colunas[j] = novo;
                        } else {
                            novo.baixo = anterior1.baixo;
                            anterior1.baixo = novo;
                        }
                    } else {
                        novo.baixo = null;
                        aux1.baixo = novo;
                    }
                } else {
                    novo.baixo = null;
                    this.colunas[j] = novo;
                }

                if (aux2) {
                    coluna = this.linhas[i].coluna;

                    while (aux2.dir && coluna < j) {
                        anterior2 = aux2;
                        aux2 = aux2.dir;
                        coluna = aux2.coluna;
                    }

                    if (aux2.dir || (!aux2.dir && coluna > j)) {
                        if (!anterior2) {
                            novo.dir = aux2;
                            this.linhas[i] = novo;
                        } else {
                            novo.dir = anterior2.dir;
                            anterior2.dir = novo;
                        }
                    } else {
                        novo.dir = null;
                        aux2.dir = novo;
                    }
                } else {
                    novo.dir = null;
                    this.linhas[i] = novo;
                }
                return true;
            }
        } else
            return false;
    };

    this.remover = function (i, j) {
        if (this.busca(i, j)) {
            var coluna = this.linhas[i].coluna;
            var aux = this.linhas[i], anterior = null;

            while (aux && coluna != j) {
                anterior = aux;
                aux = aux.dir;
                coluna = aux.coluna;
            }

            var aux2 = this.colunas[j], anterior2 = null;

            while (aux2 != aux) {
                anterior2 = aux2;
                aux2 = aux2.baixo;
            }

            if (anterior)
                anterior.dir = aux.dir;
            else
                this.linhas[i] = aux.dir;

            if (anterior2)
                anterior2.baixo = aux2.baixo;
            else
                this.colunas[j] = aux2.baixo;

            var valor = aux.info;
            return valor;
        }
        return null;
    };

    this.getIJ = function (id) {
        var linha = -1;
        var coluna = -1;

        for (var i = 0; i < this.NLINHAS; ++i) {
            var aux = this.linhas[i];
            while (aux) {
                if (aux.id == id) {
                    linha = aux.linha;
                    coluna = aux.coluna;
                    break;
                }
                aux = aux.dir;
            }
            if (aux)
                break;
        }

        return {i: linha, j: coluna};
    };

    this.proximoColuna = function (posI, posJ) {
        posI = parseInt(posI);
        posJ = parseInt(posJ);

        var aux = null;
        for (var i = posJ + 1; i < this.NCOLUNAS; ++i) {
            aux = this.busca(posI, i);
            if (aux)
                break;
        }
        return aux;
    };

    this.anteriorColuna = function (posI, posJ) {
        posI = parseInt(posI);
        posJ = parseInt(posJ);

        var aux = null;
        for (var i = posJ - 1; i >= 0; --i) {
            aux = this.busca(posI, i);
            if (aux)
                break;
        }

        return aux;
    };

    this.proximoLinha = function (posI, posJ) {
        posI = parseInt(posI);
        posJ = parseInt(posJ);

        var aux = null;
        for (var i = posI + 1; i < this.NLINHAS; ++i) {
            aux = this.busca(i, posJ);
            if (aux)
                break;

        }

        return aux;
    };

    this.anteriorLinha = function (posI, posJ) {
        posI = parseInt(posI);
        posJ = parseInt(posJ);

        var aux = null;
        for (var i = posI - 1; i >= 0; --i) {
            aux = this.busca(i, posJ);
            if (aux)
                break;
        }

        return aux;
    };

}

(function () {
    var collection = new ListaCruzada();
    var pointerDots = new Array(collection.NLINHAS + collection.NCOLUNAS);

    var animationAdd = function (linha, coluna, info) {
        UI.lock();
        var pos = {left: 50, top: 155};
        var speed = getSpeed();
        Plumb.moveTo(info.id,pos.left,pos.top + (52 * linha),2000 * speed);
        var i=0;
        var elem = collection.linhas[linha];
        while(elem!==null){
            Plumb.moveTo(info.id,pos.left + 75 + elem.coluna*52,pos.top + (52 * linha),2000 * speed);
            if(elem.coluna === coluna)
                break;
            elem = elem.dir;
            i++;
        }
        setTimeout(function () {
            connectDisc(info.id);
            UI.unlock();
            window.Eprogramada.nextQueue();
        }, (i+1) * 2000 * speed);
    },
    animationSearch = function (info) {
        UI.lock();
        var pos = {left: 50, top: 135};
        var noCorrente = null;
        var coluna = 0;
        var linha = 0;
        var i;
        var qtd = 0;
        var speed = getSpeed();
        Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);
        for (i = 0; i < collection.NLINHAS && !noCorrente; ++i) {
            noCorrente = collection.linhas[i];

            if (noCorrente) {
                while (noCorrente) {
                    qtd++;
                    Plumb.moveTo(info.id,pos.left + (52 * noCorrente.coluna) + 75, pos.top + (52 * noCorrente.linha),2000 * speed);
                    if (parseInt(noCorrente.info) == parseInt(info.valor))
                        break;
                    coluna++;
                    noCorrente = noCorrente.dir;
                }

                linha++;
                if (!noCorrente)
                    Plumb.moveTo(info.id, 50,pos.top + (52 * linha),2000 * speed);
            } else
                Plumb.moveTo(info.id, 50, pos.top + (52 * ++linha), 2000 * speed);
            qtd++;
            coluna = 0;
        }

        setTimeout(function () {
            if (noCorrente) {
                var obj = $("#" + noCorrente.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }
            var objInfo = $("#" + info.id);
            objInfo.fadeOut(1000 * speed);
            setTimeout(function () {
                UI.unlock();
                objInfo.remove();
            }, 6000 * speed);
        }, (i + qtd) * 2000 * speed);

    },
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var pos = {left: 50, top: 135};
        var noCorrente = null;
        var coluna = 0;
        var linha = 0;
        var i;
        var qtd = 0;
        
        Plumb.moveTo(info.id,pos.left,pos.top,2000 * speed);

        for (i = 0; i < collection.NLINHAS && !noCorrente; ++i) {
            noCorrente = collection.linhas[i];
            if (noCorrente) {
                while (noCorrente) {
                    qtd++;
                    Plumb.moveTo(info.id, pos.left + (52 * noCorrente.coluna) + 75, pos.top + (52 * noCorrente.linha),2000 * speed);
                    if (parseInt(noCorrente.info) == parseInt(info.valor))
                        break;
                    coluna++;
                    noCorrente = noCorrente.dir;
                }
                linha++;
                if (!noCorrente)
                    Plumb.moveTo(info.id, 50,pos.top + (52 * linha), 2000 * speed);
            } else
                Plumb.moveTo(info.id, 50, pos.top + (52 * ++linha), 2000 * speed);
            qtd++;
            coluna = 0;
        }

        setTimeout(function () {
            var objInfo = $("#" + info.id);
            if (noCorrente) {
                var obj = $("#" + noCorrente.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
            }
            objInfo.fadeOut(1000 * speed);
            setTimeout(function () {
                objInfo.remove();
                disconnectDisc(noCorrente);
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 7000 * speed);
        }, (i + qtd) * 2000 * speed);
    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:"Right"});
    },
    prepare1 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:"Bottom"});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:"Top"});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:"Left"});
    },
    connectDisc = function (id) {

        var speed = getSpeed();

        var pos = collection.getIJ(id);
        var elems = new Array(4);

        elems[0] = collection.anteriorColuna(pos.i, pos.j);
        elems[1] = collection.anteriorLinha(pos.i, pos.j);

        if (elems[0]) {
            if (elems[0].conecDir != null)
                jsPlumb.detach(elems[0].conecDir);
            elems[0].endp1 = prepare(elems[0].id);
            elems[0].conecDir = Plumb.conectar(elems[0].endp1,prepare3(id));
        } else {
            if (pointerDots[collection.NLINHAS + parseInt(pos.i)].conecDir)
                jsPlumb.detach(pointerDots[collection.NLINHAS + parseInt(pos.i)].conecDir);
            pointerDots[collection.NLINHAS + parseInt(pos.i)].conecDir = Plumb.conectar(prepare(pointerDots[collection.NLINHAS + parseInt(pos.i)].id),prepare3(id));
        }

        if (elems[1]) {
            if (elems[1].conecBaixo != null)
                jsPlumb.detach(elems[1].conecBaixo);
            elems[1].endp2 = prepare1(elems[1].id);
            elems[1].conecBaixo = Plumb.conectar(elems[1].endp2, prepare2(id));
        } else {
            if (pointerDots[pos.j].conecBaixo)
                jsPlumb.detach(pointerDots[pos.j].conecBaixo);
            pointerDots[pos.j].conecBaixo = Plumb.conectar(prepare1(pointerDots[pos.j].id), prepare2(id));
        }

        elems[2] = collection.proximoLinha(pos.i, pos.j);
        elems[3] = collection.proximoColuna(pos.i, pos.j);

        setTimeout(function () {
            if (elems[2])
                collection.busca(pos.i, pos.j).conecBaixo = Plumb.conectar(prepare1(id), prepare2(elems[2].id));

            if (elems[3])
                collection.busca(pos.i, pos.j).conecDir = Plumb.conectar(prepare(id), prepare3(elems[3].id));
        }, 100 * speed);

    },
    disconnectDisc = function (noCorrente) {
        var pos = collection.getIJ(noCorrente.id);
        var elems = new Array(4);

        elems[0] = collection.anteriorColuna(pos.i, pos.j);
        elems[1] = collection.anteriorLinha(pos.i, pos.j);
        elems[2] = collection.proximoColuna(pos.i, pos.j);
        elems[3] = collection.proximoLinha(pos.i, pos.j);


        if (elems[0]) {
            jsPlumb.detach(elems[0].conecDir);
            if (elems[2]) {
                elems[0].endp1 = prepare1(elems[0].id);
                elems[0].conecDir = Plumb.conectar(elems[0].endp1, prepare3(elems[2].id));
            } else
                elems[0].conecDir = null;
        } else {
            jsPlumb.detach(pointerDots[collection.NCOLUNAS + parseInt(pos.i)].conecDir);
            if (elems[2])
                pointerDots[collection.NCOLUNAS + parseInt(pos.i)].conecDir = Plumb.conectar(prepare(pointerDots[collection.NCOLUNAS + parseInt(pos.i)].id),prepare3(elems[2].id));
            else
                pointerDots[collection.NCOLUNAS + parseInt(pos.i)].conecDir = null;
        }

        if (elems[1]) {
            jsPlumb.detach(elems[1].conecBaixo);
            if (elems[3]) {
                elems[1].endp2 = prepare1(elems[1].id);
                elems[1].conecBaixo = Plumb.conectar(elems[1].endp2, prepare2(elems[3].id));
            } else
                elems[1].conecBaixo = null;
        } else {
            jsPlumb.detach(pointerDots[parseInt(pos.j)].conecBaixo);
            if (elems[3])
                pointerDots[parseInt(pos.j)].conecBaixo = Plumb.conectar(prepare1(pointerDots[parseInt(pos.j)].id),prepare2(elems[3].id));
            else
                pointerDots[parseInt(pos.j)].conecBaixo = null;
        }
        jsPlumb.deleteEndpoint(noCorrente.endp1);
        jsPlumb.deleteEndpoint(noCorrente.endp2);
        $("#" + noCorrente.id).remove();
        collection.remover(noCorrente.linha, noCorrente.coluna);

    },
    createDisc = function (value,linha,coluna) {
        var elem = Element.createElement(
            {className:"dinamicSmallDot altColor",
            innerHTML:"<span class='itemValue altColorTitle' style='top:7px'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value+"/"+linha+"/"+coluna,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    createPointerDot = function (top, left, radius) {
        var elem = Element.createElement(
            {className:"dotPointer",
            innerHTML:"",
            left:left,
            top:top,
            idParent:"main"});
        elem.d.style.borderRadius = radius;
        elem.conecDir = null;
        elem.conecBaixo = null;
        return elem;
    },
    populateDotArray = function () {
        for (var i = 0, j = 130; i < collection.NLINHAS; ++i, j += 52) {
            pointerDots[i] = createPointerDot(97 + "px", j + "px", "10px 10px 0px 0px");
            prepare1(pointerDots[i].id);
        }

        for (i = collection.NLINHAS, j = 247; i < collection.NLINHAS + collection.NCOLUNAS; ++i, j += 52) {
            pointerDots[i] = createPointerDot((j - 85) + "px", 65 + "px", "10px 0px 0px 10px");
            prepare(pointerDots[i].id);
        }
    },

    draw = function () {
        var main = document.getElementById('main');
        for (var i = 0; i < collection.NLINHAS; i++) {
            var d = document.createElement("div");
            d.className = "staticCruzadaValue";
            d.style.left = (i*52 + 120)+"px";
            d.style.top = "75px";
            main.appendChild(d);
            d.innerHTML = "<p style='margin:0px;color:white;font-weight:bold;width:50px;text-align:center;margin-top:2px;'> "+i+"</p>";
        }
        for (var i = 0; i < collection.NCOLUNAS; i++) {
            var d = document.createElement("div");
            d.className = "staticCruzadaValue";
            d.style.left = "43px";
            d.style.top = (i*52 + 150)+"px";
            main.appendChild(d);
            d.innerHTML = "<p style='margin:0px;margin-left:5px;color:white;font-weight:bold;line-height:50px'>"+i+"</p>";
        }

    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.AddInput('linha');
            UI.AddInput('coluna');
            UI.setProperty("primaryColorProperty",true);
            UI.lock();
            $("#main").css("height","100vh");
            $("#newStruct").click(this.newStruct);
            UI.InitInterface(this.search,this.elementToString);
        },
        search: function(){
            var value = UI.value("valor");
            var linha = UI.value("linha");
            var coluna = UI.value("coluna");
            if(value!=="" && coluna!=="" && linha!==""){
                return $(".dinamicSmallDot[title='"+value+"/"+linha+"/"+coluna+"']").length!==0;
            }
            return false;
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.valor,'linha':element.linha,'coluna':element.coluna};
                if (element.dir !== null) {
                    var nextId = (element.dir.id * 1).toString(16).toUpperCase();
                    result.direita = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.direita = 'null';
                if (element.baixo !== null) {
                    var nextId = (element.baixo.id * 1).toString(16).toUpperCase();
                    result.baixo = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.baixo = 'null';
                return result;
            }
            return false;
        },
        newStruct: function(){
            var linhas = UI.value("sizeVer","Numero de Linhas é invalido");
            var colunas = UI.value("sizeHor","Numero de Colunas é invalido");
            if(linhas!=="" && colunas!=="") {
                UI.setParameters({N_LINHAS:linhas,N_COLUNAS:colunas});
                UI.InitFunctions(Cadilag.addDisc,Cadilag.removeValue,Cadilag.searchValue);
                $("#newStruct").unbind('click');
                $("#linha").attr("max",parseInt(linhas)-1);
                $("#coluna").attr("max",parseInt(colunas)-1);
                collection.inicia(linhas,colunas);
                draw();
                populateDotArray();
                UI.unlock();
                $("#subtopbar").animate({"top":"0px"},500,function(){
                    $(this).remove();
                });
            }
        },
        addDisc: function () {
            if (UI.checkInterface()) {
                var valor = UI.value('valor');
                var linha = UI.value('linha',"Linha deve ser um número");
                var coluna = UI.value('coluna',"Coluna deve ser um número");

                if (valor !== "" && coluna !== "" && linha !== "") {
                    var info = createDisc(valor,linha,coluna);

                    var endp1 = prepare1(info.id);
                    var endp2 = prepare(info.id);
                    UI.subtitle("Inserindo o valor <b>"+valor+"</b> na linha <b>"+linha+"</b> e coluna <b>"+coluna+"</b>");
                    if (collection.insere(linha, coluna, info, endp1, endp2)) {
                        animationAdd(linha, coluna, info);
                        Plumb.tornarArrastavel(info.id);
                    } else {
                        setTimeout(function () {
                            $("#" + info.id).fadeOut(1000 * getSpeed());
                            jsPlumb.deleteEndpoint(endp1);
                            jsPlumb.deleteEndpoint(endp2);
                            $("#" + info.id).remove();
                            UI.unlock();
                            window.Eprogramada.nextQueue();
                        }, 1000 * getSpeed());
                    }
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            var valor = UI.value('valor');

            if (valor !== "") {
                UI.subtitle("Removendo o valor <b>"+valor+"</b>");
                var info = createDisc(valor);
                animationRemove(info);
            }

        },
        searchValue: function () {
            var valor = UI.value('valor');

            if (valor !== "") {
                var info = createDisc(valor);
                UI.subtitle("Buscando o valor <b>"+valor+"</b>");
                animationSearch(info);
            }
        }
    };
})();
