<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';

    $email = $_SESSION['email'];
    
    if(isset($_GET['index'])) {
        $index = (int)$_GET['index'];
    } else {
        $index = 0;
    }

    $controlador = new ControladorUsuario();
    $controlador->setUser($email);
    $firstname = $controlador->getFirstname();
    $lastname = $controlador->getLastname();
    $nickname = $controlador->getNickname();
    $imageurl = $controlador->getImage();
    $totalarquivos = $controlador->getTotalArquivos();
    $totaltopicos = $controlador->getTotalTopicosDoUsuario();
    $totalrespostas = $controlador->getTotalRespostaDoUsuario();
    $style= 'style="border-bottom: 4px solid chartreuse;"';  
    include './controladores/Turma.php';
    include './entidades/Topico.php';
    
    $max = 4;
    $maxpersonal = 3;
    $maxbusca = 8;
            
    $ini = $index*$max;
    $fi = $ini+$max;
    $inipersonal = 0;
    $isAluno = $controlador->ehAluno();
    
    if(isset($_GET['busca'])) {
        $busca = $_GET['busca'];
        $topicosbusca = $controlador->buscarTopicosPublicos($ini,$maxbusca,$busca);
    } else {
        $busca = false;
    }
    
    if($isAluno) {
        include './controladores/Aluno.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
        
        if($turma!==null) {
            $totalatv = $turma->getTotalAtividadesAbertas();
            $descricao = $turma->getDescricaoTurma();
            $linkstatus = "./class.php";
            $status='Vinculado a turma de '.$descricao['disciplina_nome'].'('.$descricao['curso_sigla'].') de '.$turma->getAno(); 
        } else {
            $solicitacao = $controlador->getSolicitacao();
            
            if(!$solicitacao) {
                $linkstatus = "./classmanager.php";
                $status='Sem turma';
                $style= 'style="border-bottom: 4px solid crimson;"';

            } else {
                $linkstatus = "./class.php";
                $status='Aguardando solicitação para a turma '.$solicitacao['disciplina_nome'].' ('.$solicitacao['curso_sigla'].') de '.$solicitacao['ano'].' ser aceita';
                $style= 'style="border-bottom: 4px solid yellow;"';
            }
            
        }
        
    } else {

        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        $turmas = $controlador->getTurmas();
        $total = count($turmas);
        $totalsolicitacoes = $controlador->getTotalSolicitacoes();

        if($total===0){
            $linkstatus = "./classmanager.php";
            $status = 'Não possui turmas';
        }
        else if($total===1) {
            $descricao = $turmas[0]->getDescricaoTurma();
            $linkstatus = "./class.php";
            $status = 'Gerenciando uma turma de '.$descricao['disciplina_nome'].'('.$descricao['curso_sigla'].') de '.$turmas[0]->getAno();
        } else {
            $linkstatus = "./class.php";
            $status = 'Gerenciando '.$total.' turmas';
        }        
        $acesso = $controlador->possuiAcesso(); 
        if($acesso) {
            $style= 'style="border-bottom: 4px solid aqua;"';
        } else {
            $style= 'style="border-bottom: 4px solid crimson;"';
            $status = 'Usuário não confirmado (Sem acesso á criação de turmas)';
        }
        
    }
    
    $title = $controlador->getTitleName();
    if($imageurl!=null && $imageurl!=='') {
        $imagefinalurl =  $imageurl.'?='.rand();
    } else {
        $imagefinalurl = 'images/userdefault.png';
    }
    
    $topicospersonal = $controlador->listarTopicosDoUsuario($inipersonal,$maxpersonal); 
    $topicos = $controlador->listarTopicosPublicos($ini,$max); 
    $total = $controlador->getTotalTopicosPublicos();
    $floor = ceil($total/$max)-1;
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Principal - <?= $title; ?></title>    
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/principalstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    </head>
    <body>
        <div class='topbar'>
            <div id="icon"></div>
            <div class="subtitle">
                <p>Principal</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p> <?= $title; ?> </p>
            </div> 
            <button id="quit" onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';">Encerrar Sessão</button>
        </div>
        <div class='sidebar'>
            <a href="./editprofile.php?highlight=image" class='imageedit'>
                <img id='imguser-fg' alt='Imagem do Perfil' src='images/editimage.png'/>
                <p>Alterar<br>Imagem</p>
            </a>
            <img id='imguser' alt='Imagem do Perfil' src='<?=$imagefinalurl; ?>'/>
            <div class="title"><p>Menu</p></div>
            <button id="edit" class="buttonW edit-img" onclick="window.location='./editprofile.php'">Editar Perfil</button>
            <div id='options'>
                <a href="./novotopico.php"><button class="buttonW newtopic-img">Novo Tópico</button></a>
                <a href="./class.php"><button class="buttonW class-img">Turma</button></a>
                <a href="./arquivos.php"><button class="buttonW folder-img">Arquivos</button></a>
                <a href="./html/CadilagStructs"><button class="buttonW structure-img">Estruturas</button></a>
            </div>
            <div id='titleuser'>
                <div onclick="toggleuserinfos(this)" id='hidetitleuser'><p>Detalhes do Perfil</p></div>
                <div id="infos" class="open">
                    <?php if($nickname!=null && $nickname!=''):?>
                            <label>Nickname</label><p><?= $nickname ?></p>
                    <?php endif; if($firstname!=null && $firstname!=''):?>
                            <label>Primeiro Nome</label><p><?= $firstname ?></p>
                    <?php endif; if($lastname!=null && $lastname!=''): ?>
                            <label>Último nome</label><p><?= $lastname ?></p>
                    <?php endif;  ?>
                    <label>Cadastrado em </label><p><?= $controlador->getDataFormatadaCadastro() ?></p>
                    <label>Email</label><p><?= $email ?></p>
                </div>                
            </div>
        </div>
        <div class="area">
            <div class="subarea" id="status" onclick="window.location = '<?= $linkstatus; ?>'" <?= $style; ?>>
                <p><b>Status: </b><?= $status; ?></p>
            </div>
            <?PHP  if($isAluno && $turma!==null && $totalatv!==0): ?>                 
                <div onclick="window.location='./class.php?highlight=openatv'" id="atvcont" class="subarea">
                    <p><b><?= $totalatv ?></b> Atividades em andamento</p>
                </div>
            <?PHP endif; ?>
            <?PHP if(!$busca): ?>
                <div class="subarea topicosarea">
                    <div class="title" style="cursor:pointer" onclick="window.location='./topicos.php';"><p>Seus tópicos</p></div>
                    <div class="topicos">
                    <?PHP
                        if(!empty($topicospersonal)):
                            foreach($topicospersonal as $topico):
                                try {
                                $totalcomments = $controlador->getTotalRespostaTopico($topico->getId());
                            ?>
                                <div class="topico-area withOption">
                                    <div class="topico-navbar"></div>
                                    <div class="topico-options">
                                        <ul>
                                            <li><a href="./topicoedit.php?id=<?=$topico->getId()?>"><button class="topico-option-edit">Editar</button></a></li>
                                            <li><button class="topico-option-delete" onclick="deletarTopico(<?=$topico->getId()?>)">Excluir</button></li>
                                        </ul>
                                    </div>
                                    <a href="./topicoview.php?id=<?= $topico->getId() ?>">
                                        <div class="topico">
                                            <div class="title"><p><?= $topico->getTituloCortado(30) ?></p></div>
                                            <div class="comment"><p><?= $totalcomments ?></p></div>                                 
                                            <div class="time"><p><?= $topico->getDataFormatada() ?> ás <?= $topico->getHoraMinimizada() ?></p></div>
                                            <div class="topicoinfos">
                                                <?PHP if($topico->getParticular()): ?>
                                                    <div class="locked"><p>Somente para Turma</p></div>
                                                <?PHP endif; ?>
                                                <?PHP if($topico->getTurma()!==null): ?>
                                                    <div class="bound"><p>Vinculado com Turma</p></div>
                                                <?PHP endif; ?>
                                                <?PHP if($topico->getReport()): ?>
                                                    <div class="bug"><p>Report</p></div>
                                                <?PHP endif; ?>
                                            </div>
                                            
                                        </div>
                                    </a>
                                </div>
                                <?PHP }catch (Exception $e){ echo $e; } endforeach; if($controlador->getTotalTopicosDoUsuario()>$maxpersonal): ?>
                                <a><div class="more" onclick="window.location='./topicos.php'"><p> Listar todos ... </p></div></a>
                            <?PHP endif; ?>
                        <?PHP else: ?>
                            <p id="empty">Vazio</p>
                        <?PHP endif; ?>
                    </div>
                </div>
                <div class="subarea topicosarea">
                    <div class="title"><p>Tópicos Públicos</p></div>
                    <div class="topicos">
                    <?PHP if(!empty($topicos)): foreach($topicos as $topico): try{ ?>
                        <a href="./topicoview.php?id=<?= $topico->getId() ?>">
                                <div class="topico">
                                    <div class="title"><p><?= $topico->getTituloCortado(30) ?></p></div>
                                    <div class="comment"><p><?= $controlador->getTotalRespostaTopico($topico->getId()) ?></p></div>                                 
                                    <div class="time"><p><?= $topico->getDataFormatada() ?> ás <?= $topico->getHoraMinimizada() ?></p></div>
                                        <div class="topicoinfos">
                                        <div class="topicouser"><p>Por: <?= $topico->getTitleNameUser() ?></p></div>
                                        <?PHP if($topico->getTurma()!==null): ?>
                                            <div class="bound"><p>Vinculado com turma</p></div>
                                        <?PHP endif; ?>
                                        <?PHP if($topico->getReport()): ?>
                                            <div class="bug"><p>Report</p></div>
                                        <?PHP endif; ?>
                                    </div>
                                </div>
                            </a>
                            <?PHP }catch (Exception $e){ echo $e; } endforeach; ?>
                        <?PHP else: ?> 
                            <p id="empty">Vazio</p>
                        <?PHP endif; ?>
                    </div>
                    <?PHP  if($total>$max): ?>
                        <div class="pageselect">
                            <button id="prev" onclick="loadpage(<?= ($index-1) ?>)" <?= ($index===0?'disabled':'') ?>><</button>
                            <button id="first"<?=($index===0?'atual="atual"':'')?> onclick="loadpage(0)">0</button>
                            <?PHP if((int)$floor!==1): 
                                $minI = max(array($index-2,1));
                                $maxI = min(array($index+3,$floor));
                                if($minI!==1): ?>
                                    <button disabled>...</button>
                                <?PHP endif; for($i=$minI;$i<$maxI;$i++): ?>
                                    <button <?= ($index===$i?'atual="atual"':'') ?> onclick="loadpage(<?= $i ?>)"><?= $i ?></button>
                                <?PHP endfor; if($maxI<(int)$floor): ?>
                                    <button disabled>...</button>
                                <?PHP endif; ?>
                            <?PHP endif; ?>
                            <button id="last" <?=($index===(int)$floor?'atual="atual"':'')?> onclick="loadpage(<?=$floor?>)"><?=$floor?></button>
                            <button id="next" onclick="loadpage(<?= ($index+1) ?>)" <?=($index===(int)$floor?'disabled':'') ?>>></button>
                        </div>   
                    <?PHP endif; ?>
                </div>
                <?PHP else:?>
                    <button style="background:rgba(0,0,0,0.4)" onclick="window.location='./profile.php'">Sair da busca</button>
                    <div class="subarea topicosarea">
                    <div class="title"><p>Resultado da Busca</p></div>
                    <div class="topicos">
                    <?PHP if(!empty($topicosbusca)): foreach($topicosbusca as $topico): try{ ?>
                            <a href="./topicoview.php?id=<?= $topico->getId() ?>">
                                <div class="topico">
                                    <div class="title"><p><?= $topico->getTituloCortado(30) ?></p></div>
                                   <div class="comment"><p><?= $controlador->getTotalRespostaTopico($topico->getId()) ?></p></div>                                 
                                   <div class="time"><p><?= $topico->getDataFormatada() ?> ás <?= $topico->getHoraMinimizada() ?></p></div>
                                        <div class="topicoinfos">
                                        <div class="topicouser"><p>Por: <?= $topico->getTitleNameUser() ?></p></div>
                                        <?PHP if($topico->getTurma()!==null): ?>
                                            <div class="bound"><p>Vinculado com turma</p></div>
                                        <?PHP endif; ?>
                                        <?PHP if($topico->getReport()): ?>
                                            <div class="bug"><p>Report</p></div>
                                        <?PHP endif; ?>
                                    </div>
                                </div>
                            </a>
                            <?PHP }catch (Exception $e){ echo $e; } endforeach; ?>
                        <?PHP else: ?> 
                            <p id="empty">Vazio</p>
                        <?PHP endif; ?>
                    </div>
                    <?PHP  if($total>$maxbusca): ?>
                        <div class="pageselect">
                            <button id="prev" onclick="loadpage(<?= ($index-1) ?>)" <?= ($index===0?'disabled':'') ?>><</button>
                            <button id="first"<?=($index===0?'atual="atual"':'')?> onclick="loadpage(0)">0</button>
                            <?PHP if((int)$floor!==1): 
                                $minI = max(array($index-2,1));
                                $maxI = min(array($index+3,$floor));
                                if($minI!==1): ?>
                                    <button disabled>...</button>
                                <?PHP endif; for($i=$minI;$i<$maxI;$i++): ?>
                                    <button <?= ($index===$i?'atual="atual"':'') ?> onclick="loadpage(<?= $i ?>)"><?= $i ?></button>
                                <?PHP endfor; if($maxI<(int)$floor): ?>
                                    <button disabled>...</button>
                                <?PHP endif; ?>
                            <?PHP endif; ?>
                            <button id="last" <?=($index===(int)$floor?'atual="atual"':'')?> onclick="loadpage(<?=$floor?>)"><?=$floor?></button>
                            <button id="next" onclick="loadpage(<?= ($index+1) ?>)" <?=($index===(int)$floor?'disabled':'') ?>>></button>
                        </div>   
                    <?PHP endif; ?>
                <?PHP endif;?>
            </div>
        </div>
        <div class="sidecontent">
            <div class="subarea">
                <form action="./profile.php" method="GET" class="pure-form">
                    <input placeholder="Buscar tópicos públicos" name="busca" value="<?PHP if($busca){echo $busca;} ?>">
                </form>
            </div>
            <div class="subarea contadores">
                <div class="title"><p>Você possui</p></div>
                <a href="./arquivos.php">
                    <div id="arquivoscounter">
                        <?php if($totalarquivos!==1): ?>
                                <p><b><?= $totalarquivos ?></b> Arquivos</p>
                        <?php else: ?>
                                <p><b>1</b> Arquivo</p>
                        <?php endif; ?>
                    </div>
                </a>
                <a href="./topicos.php">
                    <div id="topicoscounter">
                        <?php if($totaltopicos!==1): ?>
                                <p><b><?= $totaltopicos ?></b> Tópicos</p>
                        <?php else: ?>
                                <p><b>Um</b> Tópico</p>
                        <?php endif; ?>
                    </div>
                </a>
                <a href="./respostas.php">
                    <div id="respostascounter">
                        <?php if($totalrespostas!==1): ?>
                                <p><b><?= $totalrespostas ?></b> Respostas</p>
                        <?php else: ?>
                                <p><b>Uma</b> Resposta</p>
                        <?php endif; ?>
                    </div>
                </a>
                <?PHP if(!$isAluno): ?>
                <a href="./class.php">
                    <div id="solicitacoescounter">
                        <?php if($totalsolicitacoes!==1): ?>
                                <p><b><?= $totalsolicitacoes ?></b> Solicitações</p>
                        <?php else: ?>
                                <p><b>Uma</b> Solicitação</p>
                        <?php endif; ?>
                    </div>
                </a>
                <?PHP endif; ?>
            </div>
            <div class="subarea" id="ads">
                <p align="center">
                    <a href="http://www.fct.unesp.br"><img src="images/CadilagStructs/logo_unespvr.png" alt="Logo"/></a>
                </p>
            </div>
            <div class="footer">
                <p>Versão Beta 1.0</p>
                <p><small>Cadilag WEB @ 2016</small></p>
            </div>
        </div>
        <script>
            function deletarTopico(id) {
                swal({
                    title: "Você tem certeza?",
                    text: "Deseja remover por completo o tópico!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Remover",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: false,
                    closeOnCancel: true},
                        function (isConfirm)
                        {
                            if (isConfirm) {

                                var data = {"id": id};
                                $.post("./ajax/postDeleteTopico.php", data, function (result) {
                                    try {
                                        var retorno = JSON.parse(result);
                                    } catch (e) {
                                        window.console.log("falha no Parse:" + result);
                                        swal(
                                                {title: "Opss ...",
                                                    type: "error",
                                                    text: "ocorreu uma falha no servidor"});
                                        return;
                                    }
                                    if (retorno.resultado) {
                                        window.location.href = './profile.php';
                                    } else {
                                        swal(
                                                {title: "Opss ...",
                                                    type: "error",
                                                    text: "ocorreu uma falha"});
                                        window.console.log(result);
                                    }
                                });
                            }

                        }
                );
            }
            
            $(".topico-navbar").each(function(){
                $(this).next(".topico-options").hide();
                $(this).click(function(){
                    if($(this).next(".topico-options").css('display')=='none'){
                        $(".topico-options").slideUp(400);
                        $(this).next(".topico-options").slideDown(400);
                    }else{
                         $(this).next(".topico-options").slideUp(400);
                    }
                });
            });
            $(".topico-area").each(function(){
               $(this).mouseleave(function(){
                   $(this).find('.topico-options').slideUp(400);
               });
            });
            
            loadpage = function(number){
                window.location='./profile.php?index='+number+'<?= (!$busca?'':'&busca='.$busca) ?>';
            };
            
            toggleuserinfos = function(element){
               $(element).toggleClass('open');
               $('#infos').toggleClass('open');                
            };

        </script>
    </body>
</html>
