
<!DOCTYPE html>
<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './controladores/Professor.php';
include './controladores/Turma.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

$imageurl = $controlador->getImage();
if ($controlador->ehAluno()) {
    header("Location: profile.php");
}

$id = 0;

if (isset($_GET['index'])) {
    $id = $_GET['index'];
} else {
    $_GET['index'] = 0;
}
$controlador = $controlador->getProfessor();

$turma = $controlador->getTurmaByIndex($id);
$details = $turma->getDescricaoTurma();
$title = $details['disciplina_nome'] . ' (' . $details['curso_sigla'] . ') - ' . $turma->getAno();
if ($imageurl != null && $imageurl !== '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
$solicitacoes = $turma->getSolicitacoes();
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Solicitações - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/solicitacoessstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Solicitações</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title; ?></p>
            </div> 
            <div id='gotohub' onclick='toggleHUB();'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class='area'>
            <button class="pure-button" onclick="window.location = './class.php?index=<?= $id ?>';">Voltar para a Turma</button>
            <div class="title"><p>Solitações pendentes (<?= count($solicitacoes) ?>)</p></div> 
                <?php foreach ($solicitacoes as $i => $solicitacao): ?>
                <div class="solicitacao">
                    <img src="<?= $solicitacao['image'] . '?=' . rand() ?>" alt="foto de <?= $solicitacao['nome'] ?>"/>
                    <div class="title">
                        <p><?= $solicitacao['email'] ?></p>
                    </div>
                    <div class="more" id="<?= $i ?>"></div>
                    <form action="./postResponderSolicitacao.php" method="POST">
                        <input type="hidden" name="id" value="<?= $solicitacao['id'] ?>"/>
                        <input type="hidden" name="resposta" value="1"/>
                        <input type="hidden" name="index" value="<?= $id ?>"/>
                        <button class="pure-button pure-button-primary">Aceitar</button>
                    </form>
                    <form action="./postResponderSolicitacao.php" method="POST">
                        <input type="hidden" name="id" value="<?= $solicitacao['id'] ?>"/>
                        <input type="hidden" name="resposta" value="0"/>
                        <input type="hidden" name="index" value="<?= $id ?>"/>                           
                        <button class="pure-button">Recusar</button>
                    </form>
                </div>
<?PHP endforeach; ?>
        </div>
<?PHP
foreach ($solicitacoes as $i => $solicitacao):

    $nickname = $solicitacao['apelido'];
    $firstname = $solicitacao['nome'];
    $lastname = $solicitacao['sobrenome'];
    $data = $solicitacao['data_cadastro'];
    ?>
            <div class="solicitacaousuario" style="display:none;" id="<?= $i ?>">
            <?PHP if ($nickname != null && $nickname != ''): ?>
                    <label>Apelido</label><p><?= $nickname ?></p>
            <?PHP endif;
            if ($firstname != null && $firstname != ''): ?>
                    <label>Primeiro Nome</label><p><?= $firstname ?></p>
            <?PHP endif;
            if ($lastname != null && $lastname != ''): ?>
                    <label>Último nome</label><p><?= $lastname ?></p>
            <?PHP endif ?>
                <label>Cadastrado em </label><p><?= date("d/m/Y", strtotime($data)) ?></p>
            </div>
            <?PHP endforeach; ?>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location = './profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location = './editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location = './arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location = './class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location = './novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = './closesession.php';"><p>Sair</p></div>
        </div>
        <script>

            $(".more").click(function () {
                var id = $(this).attr('id');
                var ocultar = $(".solicitacaousuario[id='" + id + "']").css('display') === 'none';

                $(".solicitacaousuario").fadeOut(200);
                $(".more").removeAttr('selected');

                if (ocultar)
                {
                    setTimeout(function () {
                        $(".solicitacaousuario[id='" + id + "']").fadeIn(200);
                        $(".more[id='" + id + "']").attr('selected', '');
                    }, 200);
                }
            });

            toggleHUB = function () {
                $("#huboptions").fadeToggle(100);
            };
        </script>
    </body>
</html>
